PROGRAM TwinLaw;

USES
 Crt,Printer;

CONST
 Max=100;

TYPE
 PointedType=ARRAY[1..50] OF Boolean;
 Dynamic4Type=ARRAY[1..50,1..50] OF Integer;
 JSubType=ARRAY[1..43,1..50] OF Integer;
 ExistsType=ARRAY[1..97] OF Boolean;
 TestQType=ARRAY[1..50] OF Integer;
 Dynamic3Type=ARRAY[1..97] OF Integer;
 CosetRepType=ARRAY[1..50] OF Integer;
 DynamicType=ARRAY[1..50,1..50] OF Integer;
 RowType=ARRAY[1..50] OF Integer;
 SymbolType=ARRAY[1..3,1..32] OF STRING[7];
 SizeType=ARRAY[1..32] OF Integer;
 NumElementType=ARRAY[1..32,1..48] OF Integer;
 MultType=ARRAY[1..2,1..48,1..48] OF Integer;
 InverseType=ARRAY[1..2,1..48] OF Integer;
 SgSizeType=ARRAY[1..2,1..97] OF Integer;
 SgElementType=ARRAY[1..2,1..97,1..24] OF Integer;
 SgNumberType=ARRAY[1..32] OF Integer;
 SubGroupType=ARRAY[1..32,1..97] OF Integer;
 ElementType=ARRAY[1..2,1..2,1..48] OF STRING[12];
 SubSymType=ARRAY[1..2,1..2,1..97] OF STRING[16];
 NormalType=ARRAY[1..50] OF Integer;
 GChoiceType=ARRAY[1..100] OF Integer;

VAR
 Pointed:PointedType;
 Dynamic4:Dynamic4Type;
 Point:ExistsType;
 TestP,TestQ:TestQType;
 NumNormal:NormalType;
 Symmetry:CosetRepType;
 TestGroup2,SameSize,Dynamic3:Dynamic3Type;
 CosetRep:CosetRepType;
 TestGroup,Dynamic,Dynamic2:DynamicType;
 JSub,PElement,P,GElement,Q,Dynamic5,GxGi,Row:RowType;
 GroupSymbol:SymbolType;
 GroupsFound,GroupSize,GroupType:SizeType;
 ElementNum:NumElementType;
 Mult:MultType;
 Inverse:InverseType;
 SgSize:SgSizeType;
 SgElement:SgElementType;
 SgNumber:SgNumberType;
 SubGroups:SubGroupType;
 Elements:ElementType;
 SubSymbol:SubSymType;
 MAMA,Back,J2,NumberP,NumPair,ZZZ,AA,NumberGroups,SizeQ,JJ,Elem,RowNum,MN,Z,R,III,
 GSize,SearchItem,N,G,S,PointGroup,SubGroup,NumberRows,NumberColumns,
 JVar2,NumShown,GVar,JVar,IVar,JSVar,PVar,GElemen,GElemenS,QVar,O1,O2,O3,O4,O5,O6,O7:Integer;
 Option:Char;
 Pointy,PointGr,Found2,MultFound,Located2,Located,Found,Doubles,Check:Boolean;
 GChoice:GChoiceType;

{ Initialize prepares all neccessary variables to be used throughout the
  program.}

PROCEDURE Initialize(VAR GroupSize,GroupType:SizeType;VAR Elements:ElementType;
                     VAR ElementNum:NumElementType;VAR Mult:MultType;
                     VAR Inverse:InverseType; VAR SgSize:SgSizeType;
                     VAR SgElement:SgElementType;VAR SgNumber:SgNumberType;
                     VAR SubGroups:SubGroupType;VAR GroupSymbol:SymbolType;
                     VAR SubSymbol:SubSymType);

TYPE
 TotalType=ARRAY[1..48] OF Integer;

VAR
 SgNumberFile,CubSgSizeFile,HexSgSizeFile,CubInverseFile,HexInverseFile,
 SizeFile,TypeFile,CubSgElementFile,HexSgElementFile,ElNumFile,CubMultFile,
 InCuSgSymbolFile,ScCuSgSymbolFile,InHexSgSymbolFile,ScHexSgSymbolFile,
 ElementFile,SymbolInFile,SubGroupsFile,HexElementFile,HexMultFile:Text;
 J,K:Integer;
 Option:Char;
 Total:TotalType;

BEGIN
 ClrScr;

 {Initialize filenames}
 Assign(InCuSgSymbolFile,'CUBSUBI.DAT');
 Assign(ScCuSgSymbolFile,'CUBSUBS.DAT');
 Assign(InHexSgSymbolFile,'HEXSUBI.DAT');
 Assign(ScHexSgSymbolFile,'HEXSUBS.DAT');
 Assign(HexElementFile,'HEXELSY.DAT');
 Assign(ElementFile,'CUBELSY.DAT');
 Assign(SymbolInFile,'PGSYMBOL.DAT');
 Assign(SubGroupsFile,'SUBGROUP.DAT');
 Assign(SgNumberFile,'NUMSUB.DAT');
 Assign(CubSgElementFile,'ELSUBCU.DAT');
 Assign(HexSgElementFile,'ELSUBHE.DAT');
 Assign(CubSgSizeFile,'SUBSIZC.DAT');
 Assign(HexSgSizeFile,'SUBSIZH.DAT');
 Assign(SizeFile,'PGSIZE.DAT');
 Assign(TypeFile,'PGTYPE.DAT');
 Assign(ElNumFile,'PGNUM.DAT');
 Assign(CubMultFile,'DOUCUBM.DAT');
 Assign(HexMultFile,'DOUHEXM.DAT');
 Assign(CubInverseFile,'CUBINV.DAT');
 Assign(HexInverseFile,'HEXINV.DAT');

 {Open files}
 Reset(ElementFile);
 Reset(SubGroupsFile);
 Reset(SgNumberFile);
 Reset(CubSgElementFile);
 Reset(HexSgElementFile);
 Reset(CubSgSizeFile);
 Reset(HexSgSizeFile);
 Reset(ElNumFile);
 Reset(SizeFile);
 Reset(TypeFile);
 Reset(SymbolInFile);

 {Initialize size and type of point groups}
 FOR J:=1 TO 32 DO
  BEGIN
   Readln(SizeFile,GroupSize[J]);
   Readln(TypeFile,GroupType[J]);
   FOR K:=1 TO GroupSize[J] DO
    Read(ElNumFile,ElementNum[J,K]);
  END;
 Close(SizeFile);
 Close(TypeFile);
 Close(ElNumFile);
 Reset(CubMultFile);
 Reset(HexMultFile);

 {Initialize cubic and hexagonal double multiplication tables}
 FOR J:=1 TO 24 DO
  BEGIN
   FOR K:=1 TO 24 DO
    BEGIN
     Read(CubMultFile,Mult[1,J,K]);
     IF (J<=12) AND (K<=12) THEN
      Read(HexMultFile,Mult[2,J,K]);
    END;
  END;
 Close(CubMultFile);
 Close(HexMultFile);

 {Convert double tables to single tables}
 FOR J:=1 TO 24 DO
  BEGIN
   FOR K:=1 TO 24 DO
    BEGIN
     IF Mult[1,J,K]>48 THEN
      Mult[1,J,K]:=Mult[1,J,K]-48;
     IF (J<=12) AND (K<=12) THEN
      BEGIN
       IF Mult[2,J,K]>48 THEN
        Mult[2,J,K]:=Mult[2,J,K]-48;
      END;
    END;
  END;

 {Construction of the complete tables}
 FOR J:=1 TO 24 DO
  BEGIN
   FOR K:=1 TO 24 DO
    BEGIN
     Mult[1,J+24,K+24]:=Mult[1,J,K];
     Mult[1,J+24,K]:=Mult[1,J,K]+24;
     Mult[1,J,K+24]:=Mult[1,J,K]+24;
     IF (J<=12) AND (K<=12) THEN
      BEGIN
       Mult[2,J+12,K+12]:=Mult[2,J,K];
       Mult[2,J,K+12]:=Mult[2,J,K]+12;
       Mult[2,J+12,K]:=Mult[2,J,K]+12;
      END;
    END;
  END;
 Reset(HexInverseFile);
 Reset(CubInverseFile);

 {Initialize cubic and hexagonal inverses}
  FOR J:=1 TO 24 DO
   BEGIN
    Read(CubInverseFile,Inverse[1,J]);
    IF J<=12 THEN
     Read(HexInverseFile,Inverse[2,J]);
   END;

 {Define remaining sections of inverse array}
 FOR J:=1 TO 24 DO
  BEGIN
   Inverse[1,J+24]:=Inverse[1,J]+24;
   IF J<=12 THEN
    Inverse[2,J+12]:=Inverse[2,J]+12;
  END;

 {Initialize cubic and hexagonal subgroup sizes}
  FOR J:=1 TO 97 DO
   BEGIN
    Read(CubSgSizeFile,SgSize[1,J]);
    IF J<=53 THEN
     Read(HexSgSizeFile,SgSize[2,J]);
   END;

 {Initialize cubic subgroup elements}
 FOR J:=1 TO 97 DO
  BEGIN
   FOR K:=1 TO SgSize[1,J] DO
    BEGIN
     Read(CubSgElementFile,SgElement[1,J,K]);
    END;
  END;

 {Initialize hexagonal subgroup elements}
 FOR J:=1 TO 53 DO
  BEGIN
   FOR K:=1 TO SgSize[2,J] DO
    BEGIN
     Read(HexSgElementFile,SgElement[2,J,K]);
    END;
  END;
 Close(HexSgElementFile);

 {Initialize number of subgroups for each group}
 FOR J:=1 TO 32 DO
  BEGIN
   Readln(SgNumberFile,SgNumber[J]);
  END;
  Close(SgNumberFile);
 FOR J:=1 TO 32 DO
  BEGIN
   FOR K:=1 TO SgNumber[J] DO
    BEGIN
     Read(SubGroupsFile,SubGroups[J,K]);
    END;
  END;
  Close(SubGroupsFile);

 {Initialize point group symbols}
 FOR J:=1 TO 2 DO
  BEGIN
   FOR K:=1 TO 32 DO
    BEGIN
       Read(SymbolInFile,GroupSymbol[J,K]);
       IF (K MOD 11)=0 THEN
        Readln(SymbolInFile);
    END;
   IF J=1 THEN Readln(SymbolInFile);
  END;
 Close(SymbolInFile);

 {Initialize cubic elements of each point group}
 FOR J:=1 TO 2 DO
  BEGIN
   FOR K:=1 TO 48 DO
    BEGIN
     Read(ElementFile,Elements[1,J,K]);
     IF (K MOD 6)=0 THEN
      Readln(ElementFile);
    END;
  END;
 Close(ElementFile);

 {Initialize hexagonal elements of each point group}
 Reset(HexElementFile);
 FOR J:=1 TO 2 DO
  BEGIN
   FOR K:=1 TO 24 DO
    BEGIN
     Read(HexElementFile,Elements[2,J,K]);
     IF (K MOD 6)=0 THEN
      Readln(HexElementFile);
    END;
  END;
 Close(HexElementFile);

 {Initialize SubGroup Symbols}
 Reset(InCuSgSymbolFile);
 Reset(ScCuSgSymbolFile);
 Reset(InHexSgSymbolFile);
 Reset(ScHexSgSymbolFile);
 FOR K:=1 TO 97 DO
  BEGIN
   Read(InCuSgSymbolFile,SubSymbol[1,1,K]);
   Read(ScCuSgSymbolFile,SubSymbol[1,2,K]);
   Read(InHexSgSymbolFile,SubSymbol[2,1,K]);
   Read(ScHexSgSymbolFile,SubSymbol[2,2,K]);
   IF (K MOD 4)=0 THEN
    BEGIN
     Readln(InCuSgSymbolFile);
     Readln(ScCuSgSymbolFile);
     Readln(InHexSgSymbolFile);
     Readln(ScHexSgSymbolFile);
    END;
  END;

 {Close all remaining open files}
 Close(InCuSgSymbolFile);
 Close(ScCuSgSymbolFile);
 Close(InHexSgSymbolFile);
 Close(ScHexSgSymbolFile);
 Close(CubSgElementFile);
 Close(CubSgSizeFile);
 Close(HexSgSizeFile);
 Close(CubInverseFile);
 Close(HexInverseFile);
END;

{ Introduction displays the program's purpose and a menu. A repeat loop
  is used to reduce user errors.}

PROCEDURE Introduction(VAR Option:Char;VAR N:Integer);

BEGIN
  ClrScr;
  Writeln;
  Writeln;
  Writeln('                             NON-MAGNETIC TWIN LAWS');
  Writeln;
  Writeln;
  Writeln('                          J. SCHLESSMAN AND D.B. LITVIN  ');
  Writeln;
  Writeln('                             DEPARTMENT OF PHYSICS');
  Writeln;
  Writeln('                 THE PENNSYLVANIA STATE UNIVERSITY - BERKS CAMPUS');
  Writeln;
  Writeln('                     P.O. BOX 7009, READING, PA 19610-6009, USA');
  Writeln;
  Writeln;
  Writeln('                                 press any key');
  Option:=Readkey;
END;

Procedure Menu(VAR Option:Char;PointGroup,SubGroup,G,N:Integer);
VAR MAMA:Integer;
 BEGIN
  REPEAT
  ClrScr;
  Writeln;
  Writeln(' G= ',GroupSymbol[N,PointGroup],'  F= ',SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,SubGroup]]);
  Writeln;
  Writeln(' 1) Coset and double coset decomposition of G with respect to F.');
  Writeln(' 2) Index i and point group F(i) of domain states S(j).');
  Writeln(' 3) Permutations of domain states S(i) under elements g of G.');
  Writeln(' 4) Classes of domain pair {S(i),S(j)}.');
  Writeln(' 5) Twin laws of domain pair representatives {S(1),S(j)}.');
  Writeln(' 6) Twin laws of domain pair {S(1),gS(1)}.');
  Writeln(' 7) Twin laws of domain pair {S(i),S(j)}.');
  IF N=1 THEN
   Writeln(' 8) Change from International to Schoenflies notation.')
  ELSE IF N=2 THEN
   Writeln(' 8) Change from Schoenflies to International notation.');
  Writeln;
  Writeln(' A) Choose a new point group G.');
  Writeln(' B) Choose a new subgroup F.');
  Writeln;
  Writeln(' E) Exit program.');
  Writeln;
  Writeln(' Choose 1-8, A, B, or E');
  Option:=Readkey;
  UNTIL Option IN ['1','2','3','4','5','6','7','8','a','A','b','B','e','E'];
 END;

{ Search6 is used by Procedure TwinLaws to determine the subgroup P,(i.e. the
  subgroup Q along with the elements g*Q). If the element g does not exist,
  Q is set equal to P. Otherwise, the subgroup P is generated. It's size
  is compared with the sizes of the subgroups of the pointgroup being
  analyzed. These subgroup's elements are then compared with the elements
  of P to determine the identity of P. }

PROCEDURE Search6(VAR J,AA:Integer);

LABEL
 SkipIt,200,100,EndIt;

VAR
 A,B,D,BC,E,F,CD:Integer;

BEGIN
 BC:=1;
 CD:=1;
 NumberP:=0;
 Point[AA]:=False;
 IF GElement[AA]=0 THEN P[AA]:=Q[AA]
 ELSE
  BEGIN
   FOR A:=1 TO SizeQ DO
    BEGIN
     PElement[A]:=SgElement[GroupType[PointGroup],Q[AA],A];
     PElement[A+SizeQ]:=Mult[GroupType[PointGroup],ElementNum[PointGroup,GElement[AA]],PElement[A]];
    END;
   SizeQ:=SizeQ*2;
   IF SizeQ=GroupSize[PointGroup] THEN
    BEGIN
     Point[AA]:=True;
     P[AA]:=PointGroup;
    END
   ELSE
    BEGIN
     FOR B:=1 TO SgNumber[PointGroup] DO
      BEGIN
       IF SgSize[GroupType[PointGroup],SubGroups[PointGroup,B]]=SizeQ THEN
        BEGIN
         NumberP:=NumberP+1;
         TestP[NumberP]:=B;
        END;
      END;
 200:FOR D:=BC TO NumberP DO
      BEGIN
   100:FOR E:=CD TO SizeQ DO
        BEGIN
         FOR F:=1 TO SizeQ DO
          BEGIN
           IF PElement[E]=SgElement[GroupType[PointGroup],SubGroups[PointGroup,TestP[D]],F] THEN
            BEGIN
             Located2:=True;
             CD:=CD+1;
             GOTO 100;
            END
           ELSE Located2:=False;
          END;
         IF Located2=False THEN
          BEGIN
           BC:=BC+1;
           CD:=1;
           GOTO 200;
          END;
        END;
       IF Located2=True THEN
        BEGIN
         P[AA]:=TestP[D];
         GOTO SkipIt;
        END;
      END;
    END;
  END;
SkipIt:END;

{ Search5 is used by Procedure TwinLaws to determine whether the element g
  of the pointgroup G=G(i) which transforms 1->j and j->1 exists. It examines
  both the transformation for 1 and j for each element of G=G(i)
  simultaneously and if both are appropriate, the element exists. It is
  then stored and the Procedure is terminated. Otherwise, the element
  is non-existant and is stored as such. }

PROCEDURE Search5(VAR J:Integer);

LABEL EndIt;

VAR
 A,B:Integer;
 Exist:Boolean;

BEGIN
 FOR Elem:=1 TO GroupSize[PointGroup] DO
  BEGIN
   IF (Dynamic4[Elem,1]=Dynamic5[AA])AND(Dynamic4[Elem,Dynamic5[AA]]=1) THEN
    BEGIN
     GElement[AA]:=Elem;
     Exist:=True;
     GOTO EndIt;
    END
   ELSE Exist:=False;
  END;
 GElement[AA]:=0;
EndIt:END;

{ Search4 is used by Procedure TwinLaws to determine the subgroup Q. Q is
  the intersection of the pointgroups of the domain pair members in question.
  If the subgroup in question happend to be the subgroup being analyzed,
  it is saved as such. Otherwise, it analyzes each element of the subgroups
  to determine which are in both. Once the subgroups are entirely checked,
  the subgroup is compared with the subgroups of the pointgroup to determine
  which are of the same size. Then the subgroup is compared with each of the
  proper subgroups to determine the identity of the subgroup.}

PROCEDURE Search4(VAR AA,NumPair,PointGroup,N,J:Integer);

LABEL 100,200,EndIt,SkipIt;

VAR
 FG,AB,BC,A,B,C,D,E:Integer;

BEGIN
 A:=0;
 AB:=1;
 BC:=1;
 FG:=1;
 SizeQ:=0;
 NumberGroups:=0;
 IF Symmetry[Dynamic5[AA]]=SubGroups[PointGroup,J] THEN
  BEGIN
   Q[AA]:=SubGroups[PointGroup,J];
   SizeQ:=SgSize[GroupType[PointGroup],SubGroups[PointGroup,J]];
   GOTO SkipIt;
  END
 ELSE IF SgSize[GroupType[PointGroup],Symmetry[Dynamic5[AA]]]>=SgSize[GroupType[PointGroup],SubGroups[PointGroup,J]] THEN
  BEGIN
   FOR B:=1 TO SgSize[GroupType[PointGroup],SubGroups[PointGroup,J]] DO
    BEGIN
     FOR C:=1 TO SgSize[GroupType[PointGroup],Symmetry[Dynamic5[AA]]] DO
      BEGIN
       IF SgElement[GroupType[PointGroup],SubGroups[PointGroup,J],B]=
          SgElement[GroupType[PointGroup],Symmetry[Dynamic5[AA]],C] THEN
        BEGIN
         SizeQ:=SizeQ+1;
         TestQ[SizeQ]:=SgElement[GroupType[PointGroup],SubGroups[PointGroup,J],B];
        END;
      END;
    END;
  END
 ELSE
  BEGIN
   FOR B:=1 TO SgSize[GroupType[PointGroup],Symmetry[Dynamic5[AA]]] DO
    BEGIN
     FOR C:=1 TO SgSize[GroupType[PointGroup],SubGroups[PointGroup,J]] DO
      BEGIN
       IF SgElement[GroupType[PointGroup],Symmetry[Dynamic5[AA]],C]=
          SgElement[GroupType[PointGroup],SubGroups[PointGroup,J],B] THEN
        BEGIN
         SizeQ:=SizeQ+1;
         TestQ[SizeQ]:=SgElement[GroupType[PointGroup],SubGroups[PointGroup,J],B];
        END;
      END;
    END;
  END;
 FOR B:=1 TO SgNumber[PointGroup] DO
  BEGIN
   IF SgSize[GroupType[PointGroup],SubGroups[PointGroup,B]]=SizeQ THEN
    BEGIN
     NumberGroups:=NumberGroups+1;
     SameSize[NumberGroups]:=B;
    END;
  END;
200:FOR B:=BC TO NumberGroups DO
     BEGIN
  100:FOR D:=AB TO SizeQ DO
       BEGIN
        FOR E:=1 TO SizeQ DO
         BEGIN
          IF TestQ[D]=SgElement[GroupType[PointGroup],SubGroups[PointGroup,SameSize[B]],E] THEN
           BEGIN
            Located:=True;
            AB:=AB+1;
            GOTO 100;
           END
          ELSE Located:=False;
         END;
        IF Located=False THEN
         BEGIN
          BC:=BC+1;
          AB:=1;
          GOTO 200;
         END;
       END;
      IF Located=True THEN
       BEGIN
        Q[AA]:=SubGroups[PointGroup,SameSize[B]];
        GOTO SkipIt;
       END;
     END;
SkipIt:END;

{ Search3 is used by Procedure permutation. It determines what row the
  product of an element of G, g(i), appears in the double coset decomposition
  and thereby determines the permutation of that particular element. An
  extra logic step is added which determines the unchanged numbers in the
  event that further modifications involving permutation characters would
  be neccessary.}

PROCEDURE Search3;

LABEL
 EndIt;

VAR
 A,B:Integer;

BEGIN
 FOR A:=1 TO R DO
  BEGIN
   FOR B:=1 TO NumberColumns DO
    BEGIN
     IF Dynamic[A,B]=GxGi[RowNum] THEN
      BEGIN
       Dynamic4[Elem,RowNum]:=A;
       IF RowNum=A THEN NumNormal[Elem]:=NumNormal[Elem]+1;
      END;
    END;
  END;
EndIt:END;

{ Search2 is used by Procedure Transition to determine the pointgroup
  associated with the domain symmetry in question. First, the size of the
  pointgroup is compared with the size of the subgroups of the pointgroup in
  question. These subgroup's elements are then compared with the elements of
  the testgroup. Once all elements are found, the pointgroup is recorded and
  the procedure is terminated.}

PROCEDURE Search2(VAR SearchItem,J:Integer);

LABEL 25,50,100,110,200,Quit,EndIt;

VAR
 DE,TheSize,MD,Q,AB,BC,A,B,C,D,E,F,H,M:Integer;

BEGIN
 TheSize:=0;
 FOR AB:=1 TO 97 DO
  Dynamic3[AB]:=0;
 Q:=1;
 C:=0;
 AB:=1;
 BC:=1;
 DE:=2;
 FOR G:=1 TO SgNumber[PointGroup] DO
  BEGIN
   IF SgSize[GroupType[PointGroup],SubGroups[PointGroup,G]]=SgSize[GroupType[PointGroup],SubGroups[PointGroup,J]] THEN
    BEGIN
     C:=C+1;
     Dynamic3[C]:=SubGroups[PointGroup,G];
    END;
  END;
  TheSize:=SgSize[GroupType[PointGroup],SubGroups[PointGroup,J]];
  50:FOR A:=BC TO C DO
      BEGIN
   100:FOR H:=AB TO TheSize DO
        BEGIN
         FOR M:=1 TO TheSize DO
          BEGIN
           IF TestGroup[Z,H]=SgElement[GroupType[PointGroup],Dynamic3[A],M] THEN
            BEGIN
             Found:=True;
             AB:=AB+1;
             GOTO 100;
            END
           ELSE Found:=False;
          END;
         IF Found=False THEN
          BEGIN
           BC:=BC+1;
           AB:=1;
           GOTO 50;
          END;
         END;
       IF Found=True THEN
        BEGIN
         MN:=MN+1;
         Symmetry[MN]:=Dynamic3[A];
         GOTO EndIt;
        END;
      END;
EndIt:END;

{ Search is used frequently by Procedure TypeCoset to determine whether
  desired element (i.e. the product of two elements or the inverse of an
  element) is in the double coset in question. If it is found, the procedure
  will terminate. Otherwise, the element will be added to the decomposition.}

PROCEDURE Search(VAR SearchItem:Integer);

LABEL
 Quit,EndIt;

VAR
 A,B:Integer;

BEGIN
 FOR A:=1 TO NumberRows DO
  BEGIN
   FOR B:=1 TO NumberColumns DO
    IF SearchItem=Dynamic[A,B] THEN GOTO Quit;
  END;
 Check:=True;
 GOTO EndIt;
 Quit:Check:=False;
EndIt:END;

{ GenerateGroup is used by Procedure TwinLaws to determine the subgroup
  generated by the pointgroup F=F(1) and the element g=g(i). It initializes
  the subgroup by placing all the elements of F and g(i)*F into it. The
  procedure then begins to test the products of the subgroup thus far. Once
  an element is determined to not be in the subgroup, it is added and the
  process is repeated. Once the loops have been completely initiated, the
  test group's size is compared with all the subgroups of the pointgroup
  being analyzed. All subgroups with the correct size are then compared with
  the test group. Each element is compared with the other subgroups until
  the proper subgroup is found. Also, a logic step is added in the event
  the subgroup is actually the pointgroup in question.}

PROCEDURE GenerateGroup(VAR Option:Char;VAR N,SubGroup,PointGroup,J,AA:Integer);

LABEL EndIt,10,20,100,200;

VAR
 TotGroup,TestElement,A,B,C,D,AAA,BBB,CCC,DDD,EEE:Integer;

BEGIN
 Found2:=False;
 FOR A:=1 TO 32 DO
  GroupsFound[A]:=0;
 TotGroup:=0;
 AAA:=1;
 BBB:=1;
 CCC:=1;
 DDD:=1;
 EEE:=1;
 FOR A:=1 TO SgSize[GroupType[PointGroup],SubGroups[PointGroup,J]] DO
  BEGIN
   TestGroup2[A]:=SgElement[GroupType[PointGroup],SubGroups[PointGroup,J],A];
   TestGroup2[A+SgSize[GroupType[PointGroup],SubGroups[PointGroup,J]]]:=
         Mult[GroupType[PointGroup],CosetRep[Dynamic5[AA]],TestGroup2[A]];
  END;
 GSize:=2*SgSize[GroupType[PointGroup],SubGroups[PointGroup,J]];
200:FOR B:=DDD TO GSize DO
    BEGIN
     EEE:=1;
100:FOR C:=EEE TO GSize DO
     BEGIN
      TestElement:=Mult[GroupType[PointGroup],TestGroup2[B],TestGroup2[C]];
      FOR D:=1 TO GSize DO
       BEGIN
        IF TestElement=TestGroup2[D] THEN
         BEGIN
          MultFound:=True;
          EEE:=EEE+1;
          GOTO 100;
         END
        ELSE MultFound:=False;
       END;
     END;
      IF MultFound=False THEN
       BEGIN
        GSize:=GSize+1;
        TestGroup2[GSize]:=TestElement;
        DDD:=1;
        EEE:=1;
        GOTO 200;
       END;
    END;
 FOR A:=1 TO SgNumber[PointGroup] DO
  BEGIN
   IF SGSize[GroupType[PointGroup],SubGroups[PointGroup,A]]=GSize THEN
    BEGIN
     TotGroup:=TotGroup+1;
     GroupsFound[TotGroup]:=SubGroups[PointGroup,A];
    END;
  END;
10:FOR A:=AAA TO TotGroup DO
  BEGIN
20:FOR B:=BBB TO GSize DO
    BEGIN
     FOR C:=1 TO GSize DO
      BEGIN
       IF TestGroup2[B]=SgElement[GroupType[PointGroup],GroupsFound[A],C] THEN
        BEGIN
         Found2:=True;
         BBB:=BBB+1;
         GOTO 20;
        END
       ELSE Found2:=False;
      END;
     IF Found2=False THEN
      BEGIN
       AAA:=AAA+1;
       BBB:=1;
       GOTO 10;
      END;
    END;
   IF Found2=True THEN
    BEGIN
     Pointed[AA]:=False;
     JSub[AA]:=GroupsFound[A];
     GOTO EndIt;
    END;
  END;
IF Found2=False THEN
 Pointed[AA]:=True;
EndIt:END;

PROCEDURE GenerateGroupArb(VAR IVar,JVar:Integer);

LABEL
 EndIt,10,20,100,200;

VAR
 TotGroup,TestElement,A,B,C,D,AAA,BBB,CCC,DDD,EEE:Integer;

BEGIN
 Pointy:=False;
 Found2:=False;
 FOR A:=1 TO 32 DO
  GroupsFound[A]:=0;
 TotGroup:=0;
 AAA:=1;
 BBB:=1;
 CCC:=1;
 DDD:=1;
 EEE:=1;
 FOR A:=1 TO SgSize[GroupType[PointGroup],Symmetry[IVar]] DO
  BEGIN
   TestGroup2[A]:=SgElement[GroupType[PointGroup],Symmetry[IVar],A];
   TestGroup2[A+SgSize[GroupType[PointGroup],Symmetry[IVar]]]:=
       Mult[GroupType[PointGroup],ElementNum[PointGroup,GElemen],TestGroup2[A]];
  END;
 GSize:=2*SgSize[GroupType[PointGroup],Symmetry[IVar]];
200:FOR B:=DDD TO GSize DO
     BEGIN
      EEE:=1;
100:FOR C:=EEE TO GSize DO
     BEGIN
      TestElement:=Mult[GroupType[PointGroup],TestGroup2[B],TestGroup2[C]];
      FOR D:=1 TO GSize DO
       BEGIN
        IF TestElement=TestGroup2[D] THEN
         BEGIN
          MultFound:=True;
          EEE:=EEE+1;
          GOTO 100;
         END
        ELSE MultFound:=False;
       END;
     END;
      IF MultFound=False THEN
       BEGIN
        GSize:=GSize+1;
        TestGroup2[GSize]:=TestElement;
        DDD:=1;
        EEE:=1;
        GOTO 200;
       END;
    END;
 FOR A:=1 TO SgNumber[PointGroup] DO
  BEGIN
   IF SgSize[GroupType[PointGroup],SubGroups[PointGroup,A]]=GSize THEN
    BEGIN
     TotGroup:=TotGroup+1;
     GroupsFound[TotGroup]:=SubGroups[PointGroup,A];
    END;
  END;
10:FOR A:=AAA TO TotGroup DO
 BEGIN
20:FOR B:=BBB TO GSize DO
    BEGIN
     FOR C:=1 TO GSize DO
      BEGIN
       IF TestGroup2[B]=SgElement[GroupType[PointGroup],GroupsFound[A],C] THEN
        BEGIN
         Found2:=True;
         BBB:=BBB+1;
         GOTO 20;
        END
       ELSE Found2:=False;
      END;
     IF Found2=False THEN
      BEGIN
       AAA:=AAA+1;
       BBB:=1;
       GOTO 10;
      END;
     END;
    IF Found2=True THEN
     BEGIN
      Pointy:=False;
      JSVar:=GroupsFound[A];
      GOTO EndIt;
     END;
   END;
IF Found2=False THEN
 Pointy:=True;
EndIt:END;

PROCEDURE SearchArb4(VAR IVar,JVar:Integer);

LABEL
 SkipIt,100,200,EndIt;

VAR
 A,B,D,BC,E,F,CD:Integer;

BEGIN
 BC:=1;
 CD:=1;
 NumberP:=0;
 PointGr:=False;
 IF GElemens=0 THEN PVar:=QVar
 ELSE
  BEGIN
   FOR A:=1 TO SizeQ DO
    BEGIN
     PElement[A]:=SgElement[GroupType[PointGroup],QVar,A];
     PElement[A+SizeQ]:=Mult[GroupType[PointGroup],ElementNum[PointGroup,GElemenS],PElement[A]];
    END;
   SizeQ:=SizeQ*2;
   IF SizeQ=GroupSize[PointGroup] THEN
    BEGIN
     PointGr:=True;
     PVar:=PointGroup;
    END
   ELSE
    BEGIN
     FOR B:=1 TO SgNumber[PointGroup] DO
      BEGIN
       IF SgSize[GroupType[PointGroup],SubGroups[PointGroup,B]]=SizeQ THEN
        BEGIN
         NumberP:=NumberP+1;
         TestP[NumberP]:=B;
        END;
      END;
200:FOR D:=BC TO NumberP DO
     BEGIN
  100:FOR E:=CD TO SizeQ DO
       BEGIN
        FOR F:=1 TO SizeQ DO
         BEGIN
          IF PElement[E]=SgElement[GroupType[PointGroup],SubGroups[PointGroup,TestP[D]],F] THEN
           BEGIN
            Located2:=True;
            CD:=CD+1;
            GOTO 100;
           END
          ELSE Located2:=False;
         END;
        IF Located2=False THEN
         BEGIN
          BC:=BC+1;
          CD:=1;
          GOTO 200;
         END;
       END;
      IF Located2=True THEN
       BEGIN
        PVar:=TestP[D];
        GOTO SkipIt;
       END;
     END;
   END;
 END;
SkipIt:END;

PROCEDURE SearchArb3(VAR IVar,JVar:Integer);

LABEL
 EndIt;

VAR
 A,B:Integer;
 Exist:Boolean;

BEGIN
 FOR Elem:=1 TO GroupSize[PointGroup] DO
  BEGIN
   IF (Dynamic4[Elem,IVar]=JVar) THEN
    BEGIN
     GElemen:=Elem;
     Exist:=True;
     GOTO EndIt;
    END
   ELSE Exist:=False;
 END;
 GElemens:=0;
EndIt:END;

PROCEDURE SearchArb2(VAR IVar,JVar:Integer);

LABEL
 EndIt;

VAR
 A,B:Integer;
 Exist:Boolean;

BEGIN
 FOR Elem:=1 TO GroupSize[PointGroup] DO
  BEGIN
   IF (Dynamic4[Elem,JVar]=IVar)AND(Dynamic4[Elem,IVar]=JVar) THEN
    BEGIN
     GElemenS:=Elem;
     Exist:=True;
     GOTO EndIt;
    END
   ELSE Exist:=False;
  END;
 GElemenS:=0;
EndIt:END;

PROCEDURE SearchArb1(VAR IVar,JVar:Integer);

LABEL
 100,200,EndIt,SkipIt;

VAR
 FG,AB,BC,A,B,C,D,E:Integer;

BEGIN
 A:=0;
 AB:=1;
 BC:=1;
 FG:=1;
 SizeQ:=0;
 IF Symmetry[IVar]=Symmetry[JVar] THEN
  BEGIN
   QVar:=SubGroups[PointGroup,SubGroup];
   SizeQ:=SgSize[GroupType[PointGroup],Symmetry[IVar]];
   GOTO SkipIt;
  END
 ELSE IF SgSize[GroupType[PointGroup],Symmetry[IVar]]>=SgSize[GroupType[PointGroup],SubGroups[PointGroup,SubGroup]] THEN
  BEGIN
   FOR B:=1 TO SgSize[GroupType[PointGroup],Symmetry[IVar]] DO
    BEGIN
     FOR C:=1 TO SgSize[GroupType[PointGroup],Symmetry[JVar]] DO
      BEGIN
      IF SgElement[GroupType[PointGroup],Symmetry[IVar],B]=SgElement[GroupType[PointGroup],Symmetry[JVar],C] THEN
       BEGIN
        SizeQ:=SizeQ+1;
        TestQ[SizeQ]:=SgElement[GroupType[PointGroup],Symmetry[IVar],B];
       END;
     END;
    END;
  END
   ELSE
    BEGIN
     FOR B:=1 TO SgSize[GroupType[PointGroup],Symmetry[JVar]] DO
      BEGIN
       FOR C:=1 TO SgSize[GroupType[PointGroup],Symmetry[IVar]] DO
        BEGIN
         IF SgElement[GroupType[PointGroup],Symmetry[JVar],C]=SgElement[GroupType[PointGroup],Symmetry[IVar],B] THEN
          BEGIN
           SizeQ:=SizeQ+1;
           TestQ[SizeQ]:=SgElement[GroupType[PointGroup],Symmetry[JVar],B];
          END;
        END;
      END;
    END;
   FOR B:=1 TO SgNumber[PointGroup] DO
    BEGIN
    IF SgSize[GroupType[PointGroup],SubGroups[PointGroup,B]]=SizeQ THEN
     BEGIN
      NumberGroups:=NumberGroups+1;
      SameSize[NumberGroups]:=B;
     END;
   END;
 200:FOR B:=BC TO NumberGroups DO
      BEGIN
   100:FOR D:=AB TO SizeQ DO
    BEGIN
     FOR E:=1 TO SizeQ DO
      BEGIN
       IF TestQ[D]=SgElement[GroupType[PointGroup],SubGroups[PointGroup,SameSize[B]],E] THEN
        BEGIN
         Located:=True;
         AB:=D+1;
         GOTO 100;
        END
       ELSE Located:=False;
      END;
     IF Located= False THEN
      BEGIN
       BC:=B+1;
       AB:=1;
       GOTO 200;
      END;
    END;
   IF Located=True THEN
    BEGIN
     QVar:=SubGroups[PointGroup,SameSize[B]];
     GOTO SkipIt;
    END;
  END;
SkipIt:END;

PROCEDURE SearchArb44(VAR JVar2:Integer);

LABEL
 EndIt;

VAR
 A,B:Integer;
 Exist:Boolean;

BEGIN
 FOR Elem:=1 TO GroupSize[PointGroup] DO
  BEGIN
   IF (Dynamic4[Elem,1]=JVar2) THEN
    BEGIN
     GElemen:=Elem;
     Exist:=True;
     GOTO EndIt;
    END
   ELSE Exist:=False;
 END;
 GElemens:=0;
EndIt:END;

PROCEDURE SearchArb33(VAR JVar2:Integer);

LABEL
 SkipIt,200,100,EndIt;

VAR
 A,B,D,BC,E,F,CD:Integer;

BEGIN
 BC:=1;
 CD:=1;
 NumberP:=0;
 PointGr:=False;
 IF GElemens=0 THEN PVar:=QVar
 ELSE
  BEGIN
   FOR A:=1 TO SizeQ DO
    BEGIN
     PElement[A]:=SgElement[GroupType[PointGroup],QVar,A];
     PElement[A+SizeQ]:=Mult[GroupType[PointGroup],ElementNum[PointGroup,Gelemens],PElement[A]];
    END;
   SizeQ:=SizeQ*2;
   IF SizeQ=GroupSize[PointGRoup] THEN
    BEGIN
     PointGr:=True;
     PVar:=PointGroup;
    END
   ELSE
    BEGIN
     FOR B:=1 TO SgNumber[PointGroup] DO
      BEGIN
       IF SgSIze[GroupType[PointGroup],SubGroups[PointGroup,B]]=SizeQ THEN
        BEGIN
         NumberP:=NumberP+1;
         TestP[NumberP]:=B;
        END;
      END;
200:FOR D:=BC TO NumberP DO
     BEGIN
  100:FOR E:=CD TO SizeQ DO
       BEGIN
        FOR F:=1 TO SizeQ DO
         BEGIN
          IF PElement[E]=SgElement[GroupType[PointGroup],SubGroups[PointGroup,TestP[D]],F] THEN
           BEGIN
            Located2:=True;
            CD:=E+1;
            GOTO 100;
           END
          ELSE Located2:=False;
         END;
        IF Located2=False THEN
         BEGIN
          BC:=D+1;
          CD:=1;
          GOTO 200;
         END;
       END;
      IF Located2=True THEN
       BEGIN
        PVar:=TestP[D];
        GOTO SkipIt;
       END;
     END;
   END;
 END;
SkipIt:END;

PROCEDURE SearchArb22(VAR JVar2:Integer);

LABEL
 EndIt;

VAR
 A,B:Integer;
 Exist:Boolean;

BEGIN
 FOR Elem:=1 TO GroupSize[PointGroup] DO
  BEGIN
   IF (Dynamic4[Elem,1]=JVar2)AND(Dynamic4[Elem,JVar2]=1) THEN
    BEGIN
     GElemens:=Elem;
     Exist:=True;
     GOTO EndIt;
    END
   ELSE Exist:=False;
  END;
 GElemens:=0;
EndIt:END;

PROCEDURE SearchArb11(VAR JVar2:Integer);

LABEL
 100,200,EndIt,SkipIt;

VAR
 FG,AB,BC,C,D,E,A,B:Integer;

BEGIN
 A:=0;
 AB:=1;
 BC:=1;
 FG:=1;
 SizeQ:=0;
 NumberGroups:=0;
 IF Symmetry[{Dynamic5}JVar2]=SubGroups[PointGroup,SubGroup] THEN
  BEGIN
   QVar:=SubGroups[PointGroup,SubGroup];
   SizeQ:=SgSize[GroupType[PointGroup],SubGroups[PointGroup,SubGroup]];
   GOTO SkipIt;
  END
 ELSE IF SgSize[GroupType[PointGroup],Symmetry[JVar2]]>=SgSize[GroupType[PointGroup],SubGroups[PointGroup,SubGroup]] THEN
  BEGIN
   FOR B:=1 TO SgSize[GroupType[PointGroup],SubGroups[PointGroup,SubGroup]] DO
    BEGIN
     FOR C:=1 TO SgSize[GroupType[PointGroup],Symmetry[JVar2]] DO
      BEGIN
       IF SgElement[GroupType[PointGroup],SubGroups[PointGroup,SubGroup],B]=
          SgElement[GroupType[PointGroup],Symmetry[JVar2],C] THEN
        BEGIN
         SizeQ:=SizeQ+1;
         TestQ[SizeQ]:=SgElement[GroupType[PointGroup],SubGroups[PointGroup,SubGroup],B];
        END;
      END;
    END;
  END
 ELSE
  BEGIN
   FOR B:=1 TO SgSize[GroupType[PointGroup],Symmetry[JVar2]] DO
    BEGIN
     FOR C:=1 TO SgSize[GroupType[PointGroup],SubGroups[PointGroup,SubGroup]] DO
      BEGIN
       IF SgElement[GroupType[PointGroup],Symmetry[JVar2],C]=
          SgElement[GroupType[PointGroup],SubGroups[PointGroup,SubGroup],B] THEN
        BEGIN
         SizeQ:=SizeQ+1;
         TestQ[SizeQ]:=SgElement[GroupType[PointGroup],SubGroups[PointGroup,SubGroup],B];
        END;
      END;
    END;
  END;
 FOR B:=1 TO SgNumber[PointGroup] DO
  BEGIN
   IF SgSIze[GroupType[PointGroup],SubGroups[PointGroup,B]]=SizeQ THEN
    BEGIN
     NumberGroups:=NumberGroups+1;
     SameSize[NumberGroups]:=B;
    END;
  END;
200:FOR B:=BC TO NumberGroups DO
     BEGIN
  100:FOR D:=AB TO SizeQ DO
       BEGIN
       FOR E:=1 TO SizeQ DO
        BEGIN
        IF TestQ[D]=SgElement[GroupType[PointGroup],SubGroups[PointGroup,SameSize[B]],E] THEN
         BEGIN
          Located:=True;
          AB:=AB+1;
          GOTO 100;
         END
        ELSE Located:=False;
       END;
      IF Located=False THEN
       BEGIN
        BC:=BC+1;
        AB:=1;
        GOTO 200;
       END;
    END;
    IF Located=True THEN
     BEGIN
      QVar:=SubGroups[PointGroup,SameSize[B]];
      GOTO SkipIt;
     END;
  END;
SkipIt:END;

PROCEDURE GenerateGroupArb1(VAR JVar2:Integer);

LABEL
 EndIt,10,20,100,200;

VAR
 TotGroup,TestElement,A,B,C,D,AAA,BBB,CCC,DDD,EEE:Integer;

BEGIN
 Pointy:=False;
 Found2:=False;
 FOR A:=1 TO 32 DO
  GroupsFound[A]:=0;
 TotGroup:=0;
 AAA:=1;
 BBB:=1;
 CCC:=1;
 DDD:=1;
 EEE:=1;
 FOR A:=1 TO SgSize[GroupType[PointGroup],SubGroups[PointGroup,SubGroup]] DO
  BEGIN
   Testgroup2[A]:=SgElement[GroupType[PointGroup],SubGroups[PointGroup,SubGroup],A];
   TestGroup2[A+SgSize[GroupType[PointGroup],SubGroups[PointGroup,SubGroup]]]:=
             Mult[GroupType[PointGroup],ElementNum[PointGroup,GElemen],TestGroup2[A]];
  END;
 GSize:=2*SgSIze[GroupType[PointGroup],SubGroups[PointGroup,SubGroup]];
200:FOR B:=DDD TO GSize DO
     BEGIN
      EEE:=1;
100:FOR C:=EEE TO GSize DO
     BEGIN
      TestElement:=Mult[GroupType[PointGroup],TestGroup2[B],TestGroup2[C]];
      FOR D:=1 TO GSize DO
       BEGIN
        IF TestElement=TestGroup2[D] THEN
         BEGIN
          MultFound:=True;
          EEE:=EEE+1;
          GOTO 100;
         END
        ELSE MultFound:=False;
       END;
     END;
    IF MultFound=False THEN
     BEGIN
      GSize:=GSize+1;
      TestGroup2[GSize]:=TestElement;
      DDD:=1;
      EEE:=1;
      GOTO 200;
     END;
  END;
 FOR A:=1 TO SgNumber[PointGroup] DO
  BEGIN
   IF SgSize[GroupType[PointGroup],SubGroups[PointGroup,A]]=GSize THEN
    BEGIN
     TotGroup:=TotGroup+1;
     GroupsFound[TotGroup]:=SubGroups[PointGroup,A];
    END;
  END;
10:FOR A:=AAA TO TotGroup DO
 BEGIN
20:FOR B:=BBB TO GSize DO
    BEGIN
     FOR C:=1 TO GSize DO
      BEGIN
       IF TestGroup2[B]=SgElement[GroupType[PointGroup],GroupsFound[A],C] THEN
        BEGIN
         Found2:=True;
         BBB:=BBB+1;
         GOTO 20;
        END
       ELSE Found2:=False;
      END;
     IF Found2=False THEN
      BEGIN
       AAA:=AAA+1;
       BBB:=1;
       GOTO 10;
      END;
     END;
    IF Found2=True THEN
     BEGIN
      Pointy:=False;
      JSVar:=GroupsFound[A];
      GOTO EndIt;
     END;
   END;
IF Found2=False THEN
 Pointy:=True;
EndIt:END;

PROCEDURE PrintArbitraryTwin(VAR Option:Char;VAR N,SubGroup,PointGroup,J:Integer);

LABEL
 Take2;

VAR
 LineNum,A,B:Integer;
 Options:Char;

BEGIN
 NumberGroups:=0;
 LineNum:=0;
 GElemens:=0;
 GElemen:=0;
 SearchArb1(IVar,JVar);
 SearchArb2(IVar,JVar);
 SearchArb3(IVar,JVar);
 SearchArb4(IVar,JVar);
 GenerateGroupArb(IVar,JVar);
 ClrScr;
Take2:{$I-}
 Writeln(Lst);
 Writeln(Lst,'                        Twin Laws');
 Writeln(Lst);
 Writeln(Lst,'  G= ',GroupSymbol[N,PointGroup]);
 Writeln(Lst,'  F= ',SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,J]]);
 Writeln(Lst);
 Writeln(Lst,'      For the domain pair {S(i),S(j)}={S(',IVar:2,'),S(',JVar:2,')} we give');
 Writeln(Lst);
 Writeln(Lst,'       The symmetry group of the domain pair {S(',IVar:2,'),S(',JVar:2,')}:');
 Writeln(Lst,'                 J(',IVar:2,',',JVar:2,') = F(',IVar:2,',',JVar:2,') + g('
                               ,IVar:2,',',JVar:2,')*F(',IVar:2,',',JVar:2,')');
 Writeln(Lst,'       The twinning group of the domain pair {S(',IVar:2,'),S(',JVar:2,')}:');
 Writeln(Lst,'                 K(',IVar:2,',',JVar:2,') = < F(',IVar:2,'), g(',IVar:2,',',JVar:2,') >');
 Writeln(Lst);
 Writeln(Lst,'  Domain pair   J(',IVar:2,',',JVar:2,')        F(',IVar:2,',',JVar:2,')        g(',IVar:2,',',JVar:2,')*');
 Writeln(Lst,'  {S(i),S(j)}   K(',IVar:2,',',JVar:2,')        F(',IVar:2,')           g(',IVar:2,',',JVar:2,')');
 Writeln(Lst,'--------------------------------------------------------------------');
 Writeln(Lst);
 LineNum:=17;
 IF (GElemens<>0)AND(PointGr=False) THEN
 Writeln(Lst,'  {S(',IVar:2,'),S(',JVar:2,')} ',SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,PVar]],
         SubSymbol[GroupType[PointGroup],N,QVar],Elements[GroupType[PointGroup],N,ElementNum[PointGroup,GElemens]])
 ELSE IF (GElemens<>0)AND(PointGr=True) THEN
  Writeln(Lst,'  {S(',IVar:2,'),S(',JVar:2,')} ',GroupSymbol[N,PointGroup],'         ',
             SubSymbol[GroupType[PointGroup],N,QVar],Elements[GroupType[PointGroup],N,ElementNum[PointGroup,GElemens]])
 ELSE IF GElemens=0 THEN
  Writeln(Lst,'  {S(',IVar:2,'),S(',JVar:2,')} ',SubSymbol[GroupType[PointGroup],N,QVar],
             SubSymbol[GroupType[PointGroup],N,QVar],'None');
 Writeln(Lst);
 IF Pointy=True THEN
  Writeln(Lst,'                ',GroupSymbol[N,PointGroup],'         ',
          SubSymbol[GroupType[PointGroup],N,Symmetry[IVar]],Elements[GroupType[PointGroup],N,ElementNum[PointGroup,GElemen]])
 ELSE
  Writeln(Lst,'                ',SubSymbol[GroupType[PointGroup],N,JSVar],SubSymbol[GroupType[PointGroup],N,Symmetry[IVar]],
         Elements[GroupType[PointGroup],N,ElementNum[PointGroup,GElemen]]);
 LineNum:=LineNum+3;
 FOR A:=1 TO (66-LineNum) DO
  Writeln(Lst);
 {$I-}
 IF IOResult<>0 THEN
  BEGIN
   ClrScr;
   Writeln;
   Writeln(' An error has occured with the printer, please check that printer is');
   Writeln(' in proper order and press enter to try again.');
   Readln;
   ClrScr;
   Write(' Printing...');
   GOTO Take2;
  END;
END;

PROCEDURE ArbitraryTwin(VAR Option:Char;VAR N,SubGroup,PointGroup,J,O7:Integer);

VAR
 LineNum,A,B:Integer;
 Options:Char;

BEGIN
 NumberGroups:=0;
 PVar:=0;
 QVar:=0;
 GElemens:=0;
 GElemen:=0;
 ClrScr;
 SearchArb1(IVar,JVar);
 SearchArb2(IVar,JVar);
 SearchArb3(IVar,JVar);
 SearchArb4(IVar,JVar);
 GenerateGroupArb(IVar,JVar);
 ClrScr;
 Writeln('                        Twin Laws');
 Writeln;
 Writeln('  G= ',GroupSymbol[N,PointGroup]);
 Writeln('  F= ',SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,J]]);
 Writeln;
 Writeln('      For the domain pair {S(i),S(j)}={S(',IVar:2,'),S(',JVar:2,')}  we give');
 Writeln;
 Writeln('       The symmetry group of the domain pair {S(',IVar:2,'),S(',JVar:2,')}:');
 Writeln('                 J(',Ivar:2,',',JVar:2,') = F(',IVar:2,',',JVar:2,') + g(',IVar:2,',',JVar:2,
                           ')*F(',IVar:2,',',JVar:2,')');
 Writeln('       The twinning group of the domain pair {S(',IVar:2,'),S(',JVar:2,')}:');
 Writeln('                 K(',IVar:2,',',JVar:2,') = < F(',IVar:2,'), g(',IVar:2,',',JVar:2,') >');
 Writeln;
 Writeln('  Domain pair   J(',IVar:2,',',JVar:2,')        F(',IVar:2,',',JVar:2,')        g(',IVar:2,',',JVar:2,')*');
 Writeln('  {S(i),S(j)}   K(',IVar:2,',',JVar:2,')        F(',IVar:2,')           g(',IVar:2,',',JVar:2,')');
 Writeln('--------------------------------------------------------------------');
 Writeln;
 IF (GElemens<>0)AND(PointGr=False) THEN
 Writeln('  {S(',IVar:2,'),S(',JVar:2,')} ',SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,PVar]],
         SubSymbol[GroupType[PointGroup],N,QVar],Elements[GroupType[PointGroup],N,ElementNum[PointGroup,GElemens]])
 ELSE IF (GElemens<>0)AND(PointGr=True) THEN
  Writeln('  {S(',IVar:2,'),S(',JVar:2,')} ',GroupSymbol[N,PointGroup],'         ',
             SubSymbol[GroupType[PointGroup],N,QVar],Elements[GroupType[PointGroup],N,ElementNum[PointGroup,GElemens]])
 ELSE IF GElemens=0 THEN
  Writeln('  {S(',IVar:2,'),S(',JVar:2,')} ',SubSymbol[GroupType[PointGroup],N,QVar],
             SubSymbol[GroupType[PointGroup],N,QVar],'None');
 Writeln;
 IF Pointy=True THEN
  Writeln('                ',GroupSymbol[N,PointGroup],'         ',
          SubSymbol[GroupType[PointGroup],N,Symmetry[IVar]],Elements[GroupType[PointGroup],N,ElementNum[PointGroup,GElemen]])
 ELSE
  Writeln('                ',SubSymbol[GroupType[PointGroup],N,JSVar],SubSymbol[GroupType[PointGroup],N,Symmetry[IVar]],
         Elements[GroupType[PointGroup],N,ElementNum[PointGroup,GElemen]]);
 Writeln;
 Writeln('Press enter to continue: ');
 Readln;
 ClrScr;
END;

PROCEDURE PrintArbitraryOne(VAR Option:Char;VAR N,SubGroup,PointGroup,J,GVar:Integer);

LABEL
 Take2,Again;

VAR
 LineNum,A,B,C,AA,GUVar:Integer;
 Options:Char;

BEGIN
 NumberGroups:=0;
 PVar:=0;
 QVar:=0;
 GElemens:=0;
 GElemen:=0;
 GUVar:=GChoice[GVar];
 JVar2:=Dynamic4[GUVar,1];
 SearchArb11(JVar2);
 SearchArb22(JVar2);
 SearchArb44(JVar2);
 SearchArb33(JVar2);
 GenerateGroupArb1(JVar2);
 ClrScr;
 Writeln;
 Writeln(' printing...');
Take2:{$I-}
 Writeln(Lst);
 Writeln(Lst,'                        Twin Laws');
 Writeln(Lst);
 Writeln(Lst,'  G= ',GroupSymbol[N,PointGroup]);
 Writeln(Lst,'  F= ',SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,J]],' g= ',
                Elements[GroupType[PointGroup],N,ElementNum[PointGroup,GUVar]]);
 Writeln(Lst);
 Writeln(Lst,'  For the domain pair {S(1),gS(1)}=','{S(1),S(',JVar2:2,')} we give');
 Writeln(Lst);
 Writeln(Lst,'       The symmetry group of the domain pair {S(1),S(',JVar2:2,')}:');
 Writeln(Lst,'                 J(1,',JVar2:2,') = F(1,',JVar2:2,') + g(1,',JVar2:2,')*F(1,',JVar2:2,')');
 Writeln(Lst,'       The twinning group of the domain pair {S(1),S(',JVar2:2,')}:');
 Writeln(Lst,'                 K(1,',JVar2:2,') = < F(1), g(1,',JVar2:2,') >');
 Writeln(Lst);
 Writeln(Lst,'  Domain pair   J(1,',JVar2:2,')          F(1,',JVar2:2,')        g(1,',JVar2:2,')*');
 Writeln(Lst,'  {S(1),gS(1)}  K(1,',JVar2:2,')          F(1)           g(1,',JVar2:2,')');
 Writeln(Lst,'--------------------------------------------------------------------');
 Writeln(Lst);
 LineNum:=17;
 IF (GElemens<>0)AND(PointGr=False) THEN
  Writeln(Lst,'  {S(1) S(',JVar2:2,')}  ',SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,PVar]],
          SubSymbol[GroupType[PointGroup],N,QVar],Elements[GroupType[PointGroup],N,ElementNum[PointGroup,GElemens]])
  ELSE IF (GElemens<>0)AND(PointGr=True) THEN
   Writeln(Lst,'  {S(1) S(',JVar2:2,')}  ',GroupSymbol[N,PointGroup],'         ',SubSymbol[GroupType[PointGroup],N,QVar],
             Elements[GroupType[PointGroup],N,ElementNum[PointGroup,GElemens]])
  ELSE IF GElemens=0 THEN
   Writeln(Lst,'  {S(1) S(',JVar2:2,')}  ',SubSymbol[GroupType[PointGroup],N,QVar],
             SubSymbol[GroupType[PointGroup],N,QVar],'None');
  LineNum:=LineNum+1;
  Writeln(Lst);
  IF Pointy=True THEN
   Writeln(Lst,'                ',GroupSymbol[N,PointGroup],'         ',
           SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,SubGroup]],
           Elements[GroupType[PointGroup],N,ElementNum[PointGroup,GElemen]])
  ELSE
   Writeln(Lst,'                ',SubSymbol[GroupType[PointGroup],N,JSVar],
           SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,SubGroup]],
           Elements[GroupType[PointGroup],N,GElemen]);
  LineNum:=LineNum+2;
  FOR A:=1 TO (66-LineNum) DO
   BEGIN
    Writeln(Lst);
   END;
  {$I-}
  LineNum:=0;
  IF IOResult<>0 THEN
   BEGIN
    ClrScr;
    Writeln;
    Writeln(' An error has occured with the printer, please check that printer is');
    Writeln(' in proper order and press enter to try again.');
    Readln;
    ClrScr;
    Write(' Printing...');
    GOTO Take2;
   END;
  Writeln;
END;

PROCEDURE ArbitraryOne(VAR Option:Char;VAR N,SubGroup,PointGroup,J,O6,GVar:Integer);

LABEL
 Again;

VAR
 LineNum,A,B,C,AA,GUVar:Integer;
 Options:Char;

BEGIN
 NumberGroups:=0;
 PVar:=0;
 QVar:=0;
 GElemens:=0;
 GElemen:=0;
 GUVar:=GChoice[GVar];
 JVar2:=Dynamic4[GUVar,1];
 SearchArb11(JVar2);
 SearchArb22(JVar2);
 SearchArb44(JVar2);
 SearchArb33(JVar2);
 GenerateGroupArb1(JVar2);
 ClrScr;
 Writeln;
 Writeln('                        Twin Laws');
 Writeln;
 Writeln('  G= ',GroupSymbol[N,PointGroup]);
 Writeln('  F= ',SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,J]],'  g= ',
            Elements[GroupType[PointGroup],N,ElementNum[PointGroup,GUVar]]);
 Writeln;
 Writeln('  For the domain pair {S(1),gS(1)}=',{Elements[GroupType[PointGroup],N,ElementNum[PointGroup,GUVar]],
                'S(1)}'{S(1),S(',JVar2:2,')} we give');
 Writeln;
 Writeln('       The symmetry group of the domain pair {S(1),S(',JVar2:2,')}:');
 Writeln('                 J(1,',JVar2:2,') = F(1,',JVar2:2,') + g(1,',JVar2:2,')*F(1,',JVar2:2,')');
 Writeln('       The twinning group of the domain pair {S(1),S(',JVar2:2,')}:');
 Writeln('                 K(1,',JVar2:2,') = < F(1), g(1,',JVar2:2,') >');
 Writeln;
 Writeln('  Domain pair   J(1,',JVar2:2,')         F(1,',JVar2:2,')         g(1,',JVar2:2,')*');
 Writeln('  {S(1),gS(1)}  K(1,',JVar2:2,')         F(1)            g(1,',JVar2:2,')');
 Writeln('--------------------------------------------------------------------');
 Writeln;
 LineNum:=17;
 IF (GElemens<>0)AND(PointGr=False) THEN
  Writeln('  {S(1) S(',JVar2:2,')}  ',SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,PVar]],
          SubSymbol[GroupType[PointGroup],N,QVar],Elements[GroupType[PointGroup],N,ElementNum[PointGroup,GElemens]])
  ELSE IF (GElemens<>0)AND(PointGr=True) THEN
   Writeln('  {S(1) S(',JVar2:2,')}  ',GroupSymbol[N,PointGroup],'         ',SubSymbol[GroupType[PointGroup],N,QVar],
             Elements[GroupType[PointGroup],N,ElementNum[PointGroup,GElemens]])
  ELSE IF GElemens=0 THEN
   Writeln('  {S(1) S(',JVar2:2,')}  ',SubSymbol[GroupType[PointGroup],N,QVar],
             SubSymbol[GroupType[PointGroup],N,QVar],'None');
  LineNum:=LineNum+1;
  Writeln;
  IF Pointy=True THEN
   Writeln('                ',GroupSymbol[N,PointGroup],'         ',
           SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,SubGroup]],
           Elements[GroupType[PointGroup],N,ElementNum[PointGroup,GElemen]])
  ELSE
   Writeln('                ',SubSymbol[GroupType[PointGroup],N,JSVar],
           SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,SubGroup]],
           Elements[GroupType[PointGroup],N,GElemen]);
  LineNum:=LineNum+2;
  Writeln;
  Write('Press enter to continue: ');
  Readln;
END;

PROCEDURE PrintClasses(VAR Option:Char;VAR N,SubGroup,PointGroup,J:Integer);

TYPE
 ClassesType = ARRAY[1..50,1..50,1..2] OF Integer;
 NumFoundType = ARRAY[0..50] OF Integer;

VAR
 A,B,C,LineNum,KK:Integer;
 ClassNum:ClassesType;
 Found:Boolean;
 NumFound:NumFoundType;

LABEL
 Take2;

BEGIN
 LineNum:=0;
 FOR A:=1 TO 50 DO
  BEGIN
   FOR B:=1 TO 50 DO
    BEGIN
     FOR C:=1 TO 2 DO
      ClassNum[A,B,C]:=0;
    END;
  END;
 FOR A:=0 TO 50 DO
  NumFound[A]:=0;
 ClrScr;
 NumFound[0]:=R;
 FOR A:=1 TO NumPair DO
  NumFound[A]:=1;
 FOR A:=1 TO NumPair DO
  BEGIN
   ClassNum[A,1,1]:=1;
   ClassNum[A,1,2]:=Dynamic5[A];
  END;
 FOR B:=1 TO NumPair DO
  BEGIN
   FOR A:=2 TO GroupSize[PointGroup] DO
    BEGIN
     Found:=False;
     ClassNum[B,NumFound[B]+1,1]:=Dynamic4[A,ClassNum[B,1,1]];
     ClassNum[B,NumFound[B]+1,2]:=Dynamic4[A,ClassNum[B,1,2]];
     FOR C:=1 TO NumFound[B] DO
      BEGIN
       IF (ClassNum[B,C,1]=ClassNum[B,NumFound[B]+1,1])AND(ClassNum[B,C,2]=ClassNum[B,NumFound[B]+1,2]) THEN
        BEGIN
         Found:=True;
        END;
      END;
     IF Found=False THEN NumFound[B]:=NumFound[B]+1;
    END;
  END;
Take2:{$I-}
 Writeln(Lst);
 Writeln(Lst,'                    Classes of Domain Pair');
 Writeln(Lst);
 Writeln(Lst,'  G= ',GroupSymbol[N,PointGroup],'   F= ',SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,J]]);
 Writeln(Lst);
 LineNum:=5;
 FOR B:=0 TO NumPair DO
 BEGIN
  IF B=0 THEN Write(Lst,'  1) {S( 1),S( 1)}')
  ELSE Write(Lst,' ',B+1:2,') {S( 1),S(',Dynamic5[B]:2,')}');
  FOR A:=2 TO NumFound[B] DO
   BEGIN
    IF B=0 THEN Write(Lst,' {S(',A:2,'),S(',A:2,')} ')
    ELSE Write(Lst,' {S(',ClassNum[B,A,1]:2,'),S(',ClassNum[B,A,2]:2,')} ');
    IF ((A-1) MOD 4)=0 THEN
     BEGIN
      Writeln(Lst);
      Write(Lst,'                  ');
      LineNum:=LineNum+1;
     END;
     IF LineNum>=59 THEN
      BEGIN
       FOR KK:=1 TO (66-LineNum) DO
        Writeln(Lst);
       LineNum:=0;
      END;
   END;
  Writeln(Lst);
  Writeln(Lst);
  LineNum:=LineNum+2;
  IF (LineNum>=59) AND (B<>NumPair) THEN
   BEGIN
    FOR KK:=1 TO (66-LineNum) DO
     Writeln(Lst);
    LineNum:=0;
   END;
 END;
 FOR KK:=1 TO (66-LineNum) DO
  Writeln(Lst);
 {$I+}
 IF IOResult<>0 THEN
  BEGIN
   ClrScr;
   Writeln;
   Writeln(' An error has occured with the printer, please check that printer is');
   Writeln(' in proper order and press enter to try again.');
   Readln;
   ClrScr;
   Write(' Printing...');
   GOTO Take2;
  END;
END;

PROCEDURE Classes(VAR Option:Char;VAR N,SubGroup,PointGroup,J,O4:Integer);

TYPE
 ClassesType = ARRAY[1..50,1..50,1..2] OF Integer;
 NumFoundType = ARRAY[0..50] OF Integer;

VAR
 A,B,C,LineNum:Integer;
 ClassNum:ClassesType;
 Found:Boolean;
 NumFound:NumFoundType;

LABEL
 NY;

BEGIN
 LineNum:=0;
 FOR A:=1 TO 50 DO
  BEGIN
   FOR B:=1 TO 50 DO
    BEGIN
     FOR C:=1 TO 2 DO
      ClassNum[A,B,C]:=0;
    END;
  END;
 FOR A:=0 TO 50 DO
  NumFound[A]:=0;
 ClrScr;
 NumFound[0]:=R;
 FOR A:=1 TO NumPair DO
  NumFound[A]:=1;
 FOR A:=1 TO NumPair DO
  BEGIN
   ClassNum[A,1,1]:=1;
   ClassNum[A,1,2]:=Dynamic5[A];
  END;
 FOR B:=1 TO NumPair DO
  BEGIN
   FOR A:=2 TO GroupSize[PointGroup] DO
    BEGIN
     Found:=False;
     ClassNum[B,NumFound[B]+1,1]:=Dynamic4[A,ClassNum[B,1,1]];
     ClassNum[B,NumFound[B]+1,2]:=Dynamic4[A,ClassNum[B,1,2]];
     FOR C:=1 TO NumFound[B] DO
      BEGIN
       IF (ClassNum[B,C,1]=ClassNum[B,NumFound[B]+1,1])AND(ClassNum[B,C,2]=ClassNum[B,NumFound[B]+1,2]) THEN
        BEGIN
         Found:=True;
        END;
      END;
     IF Found=False THEN NumFound[B]:=NumFound[B]+1;
    END;
  END;
 IF O4=1 THEN
 BEGIN
 Writeln;
 Writeln('                         Classes of Domain Pair');
 Writeln;
 Writeln('  G= ',GroupSymbol[N,PointGroup],'   F= ',SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,J]]);
 Writeln;
 LineNum:=5;
 FOR B:=0 TO NumPair DO
 BEGIN
  IF B=0 THEN Write('  1) {S( 1),S( 1)}')
  ELSE Write(' ',B+1:2,') {S( 1),S(',Dynamic5[B]:2,')}');
  FOR A:=2 TO NumFound[B] DO
   BEGIN
    IF B=0 THEN Write(' {S(',A:2,'),S(',A:2,')} ')
    ELSE Write(' {S(',ClassNum[B,A,1]:2,'),S(',ClassNum[B,A,2]:2,')} ');
    IF ((A-1) MOD 4)=0 THEN
     BEGIN
      Writeln;
      Write('                  ');
      LineNum:=LineNum+1;
     END;
    IF LineNum>=23 THEN
     BEGIN
      Writeln;
      Write(' Press enter to continue listing: ');
      Readln;
      ClrScr;
      Write('                  ');
      LineNum:=0;
     END;
   END;
  IF LineNum>=23 THEN
   BEGIN
    Writeln;
    Writeln;
    Write(' Press enter to continue listing: ');
    Readln;
    ClrScr;
    LineNum:=0;
    GOTO NY;
   END;
  Writeln;
  Writeln;
  LineNum:=LineNum+2;
NY:IF ((LineNum>=23)AND(B<>NumPair)) THEN
   BEGIN
    Write(' Press enter to continue listing: ');
    Readln;
    ClrScr;
    LineNum:=0;
   END;
 END;
 Write('Press enter to continue: ');
 Readln;
 END;
END;

{ PrintTwinLaws operates identical to Procedure TwinLaws except for the
  output destination and the line counter. The output is sent to the printer
  and the line counter is allowed to expand since the paper contatins more
  lines than the screen.}

PROCEDURE PrintTwinLaws(VAR Option:Char;VAR N,SubGroup,PointGroup,J:Integer);

VAR
 QQ,Z,LineNum,A,B:Integer;

LABEL
 Take2;

BEGIN
 FOR A:=1 TO 50 DO
  JSub[A]:=0;
 J2:=J;
 ClrScr;
 NumPair:=0;
 FOR B:=2 TO R DO
  BEGIN
   IF (Row[B-1]=1) OR (Row[B-1]=2) THEN
    BEGIN
     NumPair:=NumPair+1;
     Dynamic5[NumPair]:=B;
    END;
  END;
 FOR AA:=1 TO NumPair DO
  BEGIN
   Search4(AA,NumPair,PointGroup,N,J);
   Search5(J);
   IF GElement[AA]<>0 THEN Search6(J,AA);
  END;
Take2:{$I-}
 ClrScr;
 Writeln(Lst);
 Writeln(Lst,'                        Twin Laws');
 Writeln(Lst);
 Writeln(Lst,'  G= ',GroupSymbol[N,PointGroup]);
 Writeln(Lst,'  F= ',SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,J]]);
 Writeln(Lst);
 Writeln(Lst,'      For a representative domain pair {S(1),S(j)} of each class');
 Writeln(Lst,'  of domain pairs, we give ');
 Writeln(Lst);
 Writeln(Lst,'       The symmetry group of the domain pair {S(1),S(j)}:');
 Writeln(Lst,'                 J(1,j) = F(1,j) + g(1,j)*F(1,j)');
 Writeln(Lst,'       The twinning group of the domain pair {S(1),S(j)}:');
 Writeln(Lst,'                 K(1,j) = < F(1), g(1,j) >');
 Writeln(Lst);
 Writeln(Lst,'Representative');
 Writeln(Lst,'  Domain pair   J(1,j)          F(1,j)          g(1,j)*');
 Writeln(Lst,'  {S(1),S(j)}   K(1,j)          F(1)            g(1,j)');
 Writeln(Lst,'--------------------------------------------------------------------');
 Writeln(Lst);
 {$I+}
 IF IOResult<>0 THEN
  BEGIN
   ClrScr;
   Writeln;
   Writeln(' An error has occured with the printer, please check that the printer');
   Writeln(' is in proper order and press enter to try again.');
   Readln;
   ClrScr;
   Write(' Printing...');
   GOTO Take2;
  END;
 LineNum:=19;
 FOR AA:=1 TO NumPair DO
  GenerateGroup(Option,N,SubGroup,PointGroup,J,AA);
 {$I-}
 FOR A:=1 TO NumPair DO
  BEGIN
   IF (GElement[A]<>0) AND (Point[A]=False) THEN
    Writeln(Lst,' {S(1)  S(',Dynamic5[A]:2,')}  ',SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,P[A]]],
            SubSymbol[GroupType[PointGroup],N,Q[A]],Elements[GroupType[PointGroup],N,ElementNum[PointGroup,GElement[A]]])
   ELSE IF (GElement[A]<>0) AND (Point[A]=True) THEN
    Writeln(Lst,' {S(1)  S(',Dynamic5[A]:2,')}  ',GroupSymbol[N,PointGroup],'         ',
            SubSymbol[GroupType[PointGroup],N,Q[A]],Elements[GroupType[PointGroup],N,ElementNum[PointGroup,GElement[A]]])
   ELSE IF (GElement[A]=0) THEN
    Writeln(Lst,' {S(1)  S(',Dynamic5[A]:2,')}  ',SubSymbol[GroupType[PointGroup],N,Q[A]],
            SubSymbol[GroupType[PointGroup],N,Q[A]],'None');
   LineNum:=LineNum+1;
   IF (LineNum>=59) AND (A<>NumPair) THEN
    BEGIN
     FOR QQ:=1 TO (66-LineNum) DO
      Writeln(Lst);
     LineNum:=0;
    END;
   Writeln(Lst);
   IF Pointed[A]=True THEN
    Writeln(Lst,'                ',GroupSymbol[N,PointGroup],'         ',
            SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,J]],
            Elements[GroupType[PointGroup],N,CosetRep[Dynamic5[A]]])
   ELSE
    Writeln(Lst,'                ',SubSymbol[GroupType[PointGroup],N,JSub[A]],
           SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,J]]
           ,Elements[GroupType[PointGroup],N,CosetRep[Dynamic5[A]]]);
   Writeln(Lst);
   Writeln(Lst);
   LineNum:=LineNum+4;
   IF (LineNum>=59) AND (A<>NumPair) THEN
    BEGIN
     FOR QQ:=1 TO (66-LineNum) DO
      Writeln(Lst);
     LineNum:=0;
    END;
  END;
 FOR QQ:=1 TO (66-LineNum) DO
  Writeln(Lst);
  {$I+}
 IF IOResult<>0 THEN
  BEGIN
   ClrScr;
   Writeln;
   Writeln(' An error has occured with the printer, please check that the printer');
   Writeln(' is in proper order and press enter to try again.');
   Readln;
   ClrScr;
   Write(' Printing...');
   GOTO Take2;
  END;
END;

{ TwinLaws determines the twin laws of the subgroup and pointgroup in
  question. It first examines the decomposition to determine the domain
  pairs of the subgroup. It next calls on Procedures Search4, Search5, and
  Search6 if neccessary. Finally, it calls on Procedure GenerateGroup to
  determine the point group generated by g and F(1). For each domain pair,
  the procedure prints the output regarding size and existance of elements.
  Upon completion the procedure terminates.}

PROCEDURE TwinLaws(VAR Option:Char;VAR N,SubGroup,PointGroup,J,O5:Integer);

VAR
  Z,LineNum,A,B:Integer;

BEGIN
 FOR A:=1 TO 50 DO
  JSub[A]:=0;
 J2:=J;
 ClrScr;
 NumPair:=0;
 FOR B:=2 TO R DO
  BEGIN
   IF (Row[B-1]=1) OR (Row[B-1]=2) THEN
    BEGIN
     NumPair:=NumPair+1;
     Dynamic5[NumPair]:=B;
    END;
  END;
 FOR AA:=1 TO NumPair DO
  BEGIN
   Search4(AA,NumPair,PointGroup,N,J);
   Search5(J);
   IF GElement[AA]<>0 THEN Search6(J,AA);
  END;
 FOR AA:=1 TO NumPair DO
  BEGIN
   GenerateGroup(Option,N,SubGroup,PointGroup,J,AA);
  END;
 IF O5=1 THEN
 BEGIN
 ClrScr;
 Writeln('                        Twin Laws');
 Writeln;
 Writeln('  G= ',GroupSymbol[N,PointGroup]);
 Writeln('  F= ',SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,J]]);
 Writeln;
 Writeln('      For a representative domain pair {S(1),S(j)} of each class');
 Writeln('  of domain pairs, we give ');
 Writeln;
 Writeln('       The symmetry group of the domain pair {S(1),S(j)}:');
 Writeln('                 J(1,j) = F(1,j) + g(1,j)*F(1,j)');
 Writeln('       The twinning group of the domain pair {S(1),S(j)}:');
 Writeln('                 K(1,j) = < F(1), g(1,j) >');
 Writeln;
 Writeln('Representative');
 Writeln('  Domain pair   J(1,j)          F(1,j)          g(1,j)*');
 Writeln('  {S(1),S(j)}   K(1,j)          F(1)            g(1,j)');
 Writeln('--------------------------------------------------------------------');
 Writeln;
 LineNum:=19;
 FOR A:=1 TO NumPair DO
  BEGIN
   IF (GElement[A]<>0) AND (Point[A]=False) THEN
    Writeln('  {S(1)  S(',Dynamic5[A]:2,')} ',SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,P[A]]],
            SubSymbol[GroupType[PointGroup],N,Q[A]],Elements[GroupType[PointGroup],N,ElementNum[PointGroup,GElement[A]]])
   ELSE IF (GElement[A]<>0) AND (Point[A]=True) THEN
    Writeln('  {S(1)  S(',Dynamic5[A]:2,')} ',GroupSymbol[N,PointGroup],'         ',
            SubSymbol[GroupType[PointGroup],N,Q[A]],Elements[GroupType[PointGroup],N,ElementNum[PointGroup,GElement[A]]])
   ELSE IF (GElement[A]=0) THEN
    Writeln('  {S(1)  S(',Dynamic5[A]:2,')} ',SubSymbol[GroupType[PointGroup],N,Q[A]],
            SubSymbol[GroupType[PointGroup],N,Q[A]],'None');
   LineNum:=LineNum+1;
   IF (LineNum>=21) AND (A<>NumPair) THEN
    BEGIN
     Writeln;
     Write('Press enter to continue listing: ');
     Readln;
     LineNum:=0;
     ClrScr;
    END;
   Writeln;
   IF Pointed[A]=True THEN
    Writeln('                ',GroupSymbol[N,PointGroup],'         ',
            SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,J]],
            Elements[GroupType[PointGroup],N,CosetRep[Dynamic5[A]]])
   ELSE
    Writeln('                ',SubSymbol[GroupType[PointGroup],N,JSub[A]],
           SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,J]]
           ,Elements[GroupType[PointGroup],N,CosetRep[Dynamic5[A]]]);
   LineNum:=LineNum+2;
   IF (LineNum>=15) AND (A<>NumPair) THEN
    BEGIN
     Writeln;
     Write('Press enter to continue listing: ');
     Readln;
     LineNum:=0;
     ClrScr;
    END
   ELSE
    BEGIN
     Writeln;
     Writeln;
     LineNum:=LineNum+2;
    END;
  END;
 Writeln;
 Write('Press enter to continue: ');
 Readln;
 END;
END;

{ PrintPermutation operates identical to Procedure Permutation except for the
  output destination and the line counter. The output is sent to the printer
  and the line counter is permitted to expand since the paper contains more
  lines than the screen.}

PROCEDURE PrintPermutation(VAR Option:Char;VAR N,SubGroup,PointGroup,J:Integer);

VAR
 LineNum,A,DD:Integer;

LABEL
 Take2;

BEGIN
 ClrScr;
Take2:{$I-}
 LineNum:=0;
 Writeln(Lst,'                       Permutations of Domain States');
 Writeln(Lst);
 Writeln(Lst,'G= ',GroupSymbol[N,PointGroup]);
 Writeln(Lst,'F= ',SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,J]]);
 Writeln(Lst);
 Writeln(Lst,'    Permutation of the Domain States S(i) under elements of the point');
 Writeln(Lst,'    group G= ',GroupSymbol[N,PointGroup],' when F= ',SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,J]]);
 Writeln(Lst);
 Writeln(Lst,'  Element of G                  Permutation');
 Writeln(Lst,'---------------------------------------------------------------------');
 Writeln(Lst);
 LineNum:=11;
 FOR Elem:=1 TO GroupSize[PointGroup] DO
  BEGIN
   NumNormal[Elem]:=0;
   Write(Lst,'  ',Elements[GroupType[PointGroup],N,ElementNum[PointGroup,Elem]],'                  ');
   FOR RowNum:=1 TO R DO
    GxGi[RowNum]:=Mult[GroupType[PointGroup],ElementNum[PointGroup,Elem],CosetRep[RowNum]];
   FOR RowNum:=1 TO R DO
    Search3;
   IF R>15 THEN
    BEGIN
     FOR A:=1 TO 15 DO
      Write(Lst,A:3);
     Writeln(Lst);
     Write(Lst,'                                ');
     FOR A:=1 TO 15 DO
      Write(Lst,Dynamic4[Elem,A]:3);
     Writeln(Lst);
     Writeln(Lst);
     LineNum:=LineNum+3;
     IF R>30 THEN
      BEGIN
       IF LineNum>=59 THEN
        BEGIN
         FOR DD:=1 TO (66-LineNum) DO
          Writeln(Lst);
         LineNum:=0;
        END;
       Write(Lst,'                                ');
       FOR A:=16 TO 30 DO
        Write(Lst,A:3);
       Writeln(Lst);
       Write(Lst,'                                ');
       FOR A:=16 TO 30 DO
        Write(Lst,Dynamic4[Elem,A]:3);
       Writeln(Lst);
       LineNum:=LineNum+2;
       IF R>45 THEN
        BEGIN
         Writeln(Lst);
         Write(Lst,'                                ');
         IF LineNum>=59 THEN
          BEGIN
           FOR DD:=1 TO (66-LineNum) DO
            Writeln(Lst);
           LineNum:=0;
          END;
         FOR A:=31 TO 45 DO
          Write(Lst,A:3);
         Writeln(Lst);
         Write(Lst,'                                ');
         FOR A:=31 TO 45 DO
          Write(Lst,Dynamic4[Elem,A]:3);
         Writeln(Lst);
         Writeln(Lst);
         Write(Lst,'                                ');
         LineNum:=LineNum+4;
         IF LineNum>=59 THEN
          BEGIN
           FOR DD:=1 TO (66-LineNum) DO
            Writeln(Lst);
           LineNum:=0;
          END;
         FOR A:=46 TO R DO
          Write(Lst,A:3);
         Writeln(Lst);
         Write(Lst,'                                ');
         FOR A:=46 TO R DO
          Write(Lst,Dynamic4[Elem,A]:3);
         Writeln(Lst);
         Write(Lst,'                                ');
         Writeln(Lst);
         LineNum:=LineNum+3;
        END
       ELSE
        BEGIN
         IF LineNum>=59 THEN
          BEGIN
           FOR DD:=1 TO (66-LineNum) DO
            Writeln(Lst);
           LineNum:=0;
          END;
         FOR A:=31 TO R DO
          Write(Lst,A:3);
         Writeln(Lst);
         Write(Lst,'                                ');
         FOR A:=31 TO R DO
          Write(Lst,Dynamic4[Elem,A]:3);
         Writeln(Lst);
         Write(Lst,'                                ');
         LineNum:=LineNum+2;
        END
        END
     ELSE
      BEGIN
       Write(Lst,'                                 ');
       FOR A:=16 TO R DO
        Write(Lst,A:3);
       Writeln(Lst);
       Write(Lst,'                                 ');
       FOR A:=16 TO R DO
        Write(Lst,Dynamic4[Elem,A]:3);
       Writeln(Lst);
       Write(Lst,'                                 ');
       LineNum:=LineNum+2;
      END;
    END
   ELSE
    BEGIN
     FOR A:=1 TO R DO
      Write(Lst,A:3);
     Writeln(Lst);
     Write(Lst,'                                ');
     FOR A:=1 TO R DO
      Write(Lst,Dynamic4[Elem,A]:3);
     Writeln(Lst);
     Writeln(Lst);
     LineNum:=LineNum+3;
    END;
   IF (LineNum>=59) AND (Elem<>GroupSize[PointGroup]) THEN
    BEGIN
     FOR DD:=1 TO (66-LineNum) DO
      Writeln(Lst);
     LineNum:=0;
    END;
  END;
 FOR DD:=1 TO (66-LineNum) DO
  Writeln(Lst);
 LineNum:=0;
 {$I+}
 IF IOResult<>0 THEN
  BEGIN
   ClrScr;
   Writeln;
   Writeln(' An error has occured with the printer, please check that the printer');
   Writeln(' is in proper order and press enter to try again.');
   Readln;
   ClrScr;
   Write(' Printing...');
   GOTO Take2;
  END;
END;

{ Permutation determines the transformation of each of the elements in the
  pointgroup in question. For each of the elements, the procedure calls on
  Procedure Search3 to calculate the location of each element in the
  decomposition. Once completely calculated the procedure verifies the size
  of the permutation and then proceeds to print it out within the guidelines
  set by the procedure. Upon completion the program terminates.}

PROCEDURE Permutation(VAR Option:Char;VAR N,SubGroup,PointGroup,J,O3:Integer);

VAR
 LineNum,A:Integer;
 Options:Char;

BEGIN
 ClrScr;
 LineNum:=0;
 IF O3=1 THEN
 BEGIN
 Writeln('                         Permutations of Domain States');
 Writeln;
 Writeln('G= ',GroupSymbol[N,PointGroup],'   ','F= ',SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,J]]);
 Writeln;
 Writeln('    Permutation of the Domain States S(i) under elements of the point');
 Writeln('    group G= ',GroupSymbol[N,PointGroup],' when F= ',SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,J]]);
 Writeln;
 Writeln('  Element of G                  Permutation');
 Writeln('-------------------------------------------------------------------');
 Writeln;
 LineNum:=10;
 END;
 FOR Elem:=1 TO GroupSize[PointGroup] DO
  BEGIN
   NumNormal[Elem]:=0;
   IF O3=1 THEN Write('  ',Elements[GroupType[PointGroup],N,ElementNum[PointGroup,Elem]],'                ');
   FOR RowNum:=1 TO R DO
    GxGi[RowNum]:=Mult[GroupType[PointGroup],ElementNum[PointGroup,Elem],CosetRep[RowNum]];
   FOR RowNum:=1 TO R DO
    Search3;
   IF O3=1 THEN
   BEGIN
   IF R>15 THEN
    BEGIN
     FOR A:=1 TO 15 DO
      Write(A:3);
     Writeln;
     Write('                              ');
     FOR A:=1 TO 15 DO
      Write(Dynamic4[Elem,A]:3);
     Writeln;
     Writeln;
     LineNum:=LineNum+3;
     IF R>30 THEN
      BEGIN
      IF LineNum>=20 THEN
       BEGIN
        Write(' Press enter to continue listing: ');
        Readln;
        ClrScr;
        LineNum:=0;
       END;
       Write('                              ');
       FOR A:=16 TO 30 DO
        Write(A:3);
       Writeln;
       Write('                              ');
       FOR A:=16 TO 30 DO
        Write(Dynamic4[Elem,A]:3);
       Writeln;
       Writeln;
       LineNum:=LineNum+3;
       IF R>45 THEN
        BEGIN
          IF LineNum>=20 THEN
           BEGIN
            Write(' Press enter to continue listing: ');
            Readln;
            ClrScr;
            LineNum:=0;
           END;
         Write('                              ');
         FOR A:=31 TO 45 DO
          Write(A:3);
         Writeln;
         Write('                              ');
         FOR A:=31 TO 45 DO
          Write(Dynamic4[Elem,A]:3);
         Writeln;
         Writeln;
         LineNum:=LineNum+3;
         IF LineNum>=20 THEN
          BEGIN
           Write(' Press enter to continue listing: ');
           Readln;
           ClrScr;
           LineNum:=0;
          END;
         Write('                              ');
         FOR A:=46 TO R DO
          Write(A:3);
         Writeln;
         Write('                              ');
         FOR A:=46 TO R DO
          Write(Dynamic4[Elem,A]:3);
         Writeln;
         Write('                             ');
         LineNum:=LineNum+2;
        END
       ELSE
        BEGIN
         FOR A:=31 TO R DO
          Write(A:3);
         Writeln;
         Write('                              ');
         FOR A:=31 TO R DO
          Write(Dynamic4[Elem,A]:3);
         Writeln;
         Write('                              ');
         LineNum:=LineNum+2;
        END;
       END
     ELSE
      BEGIN
       Write('                               ');
       FOR A:=16 TO R DO
        Write(A:3);
       Writeln;
       Write('                               ');
       FOR A:=16 TO R DO
        Write(Dynamic4[Elem,A]:3);
       Writeln;
       Write('                               ');
       LineNum:=LineNum+2;
      END;
    END
   ELSE
    BEGIN
     FOR A:=1 TO R DO
      Write(A:3);
     Writeln;
     Write('                              ');
     FOR A:=1 TO R DO
      Write(Dynamic4[Elem,A]:3);
     Writeln;
     Write('                              ');
     LineNum:=LineNum+2;
    END;
   IF (LineNum>=20) AND (Elem<>GroupSize[PointGroup]) THEN
    BEGIN
     Writeln;
     Writeln('Press enter to continue listing: ');
     Readln;
     ClrScr;
     LineNum:=0;
    END;
  Writeln;
  LineNum:=LineNum+1;
 END;
END;
IF O3=1 THEN
 BEGIN
 Writeln('Press enter to continue: ');
 Readln;
 END;
END;

{ PrintTransition operates identical to Procedure Transition except for the
  line counter and output destination. The destination is sent to the printer
  and the line counter is allowed to expand since the paper is larger than
  the screen.}

PROCEDURE PrintTransition(VAR Option:Char;VAR N,SubGroup,PointGroup,J:Integer);

VAR
 DD,ABCD,LineNum,A,B,ABC:Integer;
 Options:Char;

LABEL
 Take2;

BEGIN
 FOR ABCD:=2 TO 50 DO
  Symmetry[ABCD]:=0;
 ClrScr;
 MN:=1;
Take2:{$I-}
 LineNum:=0;
 Writeln(Lst,'  Index i and Point Group Symmetry F(i) of Domain States S(i)');
 Writeln(Lst);
 Writeln(Lst,'G= ',GroupSymbol[N,PointGroup]);
 Writeln(Lst,'F= ',SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,J]]);
 Writeln(Lst);
 Writeln(Lst,'                               Coset                 Domain State');
 Writeln(Lst,' Index  Domain State      Representative             Point Group');
 Writeln(Lst,'   i        S(i)                g(i)                     F(i)');
 Writeln(Lst,'---------------------------------------------------------------------------');
 Writeln(Lst);
 {$I+}
 IF IOResult<>0 THEN
  BEGIN
   ClrScr;
   Writeln;
   Writeln(' An error has occured with the printer, please check that the printer');
   Writeln(' is in proper order and press enter to try again.');
   Readln;
   ClrScr;
   Write(' Printing...');
   GOTO Take2;
  END;
 LineNum:=8;
 FOR A:=1 TO R DO
  CosetRep[A]:=Dynamic[A,1];
 FOR A:=1 TO R DO
  BEGIN
   FOR B:=1 TO SgSize[GroupType[PointGroup],SubGroups[PointGroup,J]] DO
    BEGIN
     TestGroup[A,B]:=Mult[GroupType[PointGroup],CosetRep[A],SgElement[GroupType[PointGroup],SubGroups[PointGroup,J],B]];
     TestGroup[A,B]:=Mult[GroupType[PointGroup],TestGroup[A,B],Inverse[GroupType[PointGroup],CosetRep[A]]];
    END;
  END;
 FOR Z:=2 TO R DO
  Search2(Z,J);
 IF N=1 THEN
  Writeln  (Lst,'   1       S( 1)        =      1           S(1)       F( 1)= ',SubSymbol[GroupType[PointGroup],
            N,SubGroups[PointGroup,J]]);
 IF N=2 THEN
  Writeln  (Lst,'   1       S( 1)        =     C1           S(1)       F( 1)= ',SubSymbol[GroupType[PointGroup],
            N,SubGroups[PointGroup,J]]);
 LineNum:=LineNum+1;
 FOR A:=2 TO R DO
  BEGIN
    Writeln(Lst,'  ',A:2,'       S(',A:2,')','=':9,'      ',Elements[GroupType[PointGroup],N,CosetRep[A]],
                'S(1)       F(',A:2,')= ',SubSymbol[GroupType[PointGroup],N,Symmetry[A]]);
   LineNum:=LineNum+1;
   IF (LineNum>=59) AND (A<>R) THEN
    BEGIN
     FOR DD:=1 TO (66-LineNum) DO
      Writeln(Lst);
     LineNum:=0;
    END;
  END;
 FOR DD:=1 TO (66-LineNum) DO
  Writeln(Lst);
 LineNum:=0;
END;

{ Transition determines the pointgroups of the domains. First, each coset
  representative is stored in memory. Next, the pointgroup of each domain
  is stored. The pointgroup is then compared with all subgroups of the
  pointgroup in question to find common size. Once this is completed, the
  elements of the pointgroup are compared with the elements of each subgroup
  to determine the identity of the pointgroup. Upon completion the procedure
  is terminated.}

PROCEDURE Transition(VAR Option:Char;VAR N,SubGroup,PointGroup,J,O2:Integer);

VAR
 ABCD,LineNum,A,B,ABC:Integer;
 Options:Char;

BEGIN
 FOR ABCD:=2 TO 50 DO
  Symmetry[ABCD]:=0;
 Symmetry[1]:=SubGroups[PointGroup,J];
 ClrScr;
 MN:=1;
 LineNum:=0;
 IF O2=1 THEN
 BEGIN
 Writeln;
 Writeln('    Index i and Point Group Symmetry F(i) of Domain States S(i)');
 Writeln;
 Writeln('G= ',GroupSymbol[N,PointGroup]);
 Writeln('F= ',SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,J]]);
 Writeln;
 Writeln('                               Coset                 Domain State');
 Writeln(' Index  Domain State      Representative             Point Group');
 Writeln('   i        S(i)                g(i)                     F(i)');
 Writeln('---------------------------------------------------------------------------');
 Writeln;
 LineNum:=11;
 END;
 FOR A:=1 TO R DO
  CosetRep[A]:=Dynamic[A,1];
 FOR A:=1 TO R DO
  BEGIN
   FOR B:=1 TO SgSize[GroupType[PointGroup],SubGroups[PointGroup,J]] DO
    BEGIN
     TestGroup[A,B]:=Mult[GroupType[PointGroup],CosetRep[A],SgElement[GroupType[PointGroup],SubGroups[PointGroup,J],B]];
     TestGroup[A,B]:=Mult[GroupType[PointGroup],TestGroup[A,B],Inverse[GroupType[PointGroup],CosetRep[A]]];
    END;
  END;
 FOR Z:=2 TO R DO
  Search2(Z,J);
 IF O2=1 THEN
 BEGIN
 IF N=1 THEN
  Writeln  ('   1       S( 1)        =      1           S(1)       F( 1)= ',SubSymbol[GroupType[PointGroup],
            N,SubGroups[PointGroup,J]]);
 IF N=2 THEN
  Writeln  ('   1       S( 1)        =     C1           S(1)       F( 1)= ',SubSymbol[GroupType[PointGroup],
            N,SubGroups[PointGroup,J]]);
 LineNum:=LineNum+1;
 FOR A:=2 TO R DO
  BEGIN
   Writeln('  ',A:2,'       S(',A:2,')','=':9,'      ',Elements[GroupType[PointGroup],N,CosetRep[A]],
                'S(1)       F(',A:2,')= ',SubSymbol[GroupType[PointGroup],N,Symmetry[A]]);
   LineNum:=LineNum+1;
   IF (LineNum>=20) AND (A<>R) THEN
    BEGIN
     Writeln;
     Write('Press enter to continue listing: ');
     Readln;
     ClrScr;
     LineNum:=0;
    END;
  END;
  Writeln;
  Writeln('Press enter to continue: ');
  Readln;
  ClrScr;
 END;
 Writeln;
END;

{ PrintCoset operates identical to TypeCoset aside from the line counter and
  the destination of the output. The line counter is permitted to grow to
  larger sizes since the printer page contains more lines than the screen.
  The output also is sent to the printer as opposed to the screen.}

PROCEDURE PrintCoset(VAR Option:Char;VAR N,SubGroup,PointGroup:Integer;
                     VAR GroupSymbol:SymbolType;VAR SubSymbol:SubSymType;
                     VAR GroupType:SizeType;VAR SubGroups:SubGroupType;
                     VAR J:Integer);

LABEL Take2,600,500,400,220,100,211,300,Quit;

VAR
 DD,A,Code,WhereTo,MJ,C,JQ,B,InvG,H,V,P,T,O,W,G,F,S,Q,K,L,LineNum,X,M,NumberR,
 NumberR1:Integer;
 Options:STRING[2];

BEGIN
 ClrScr;
 IF JJ=1 THEN
  BEGIN
   Writeln;
   Writeln('                            Printing Note');
   Writeln;
   Writeln('     In order to ensure proper printing, please check that the');
   Writeln(' printer is online and the print head is set at a desirable ');
   Writeln(' location near the top of a new page.');
   Writeln;
   Writeln;
   Write('Press enter to print ');
   Readln;
  END;
 ClrScr;
 FOR A:=1 TO 50 DO
  BEGIN
   FOR B:=1 TO 50 DO
    BEGIN
     Dynamic[A,B]:=0;
     Dynamic2[A,B]:=0;
    END;
   Row[A]:=0;
  END;
 Check:=False;
 Doubles:=False;
 Q:=1;
 T:=1;
 P:=1;
 G:=PointGroup;
 S:=J;
Take2:{$I-}
 LineNum:=0;
 Writeln(Lst);
 Writeln(Lst,'            Coset and Double Coset Decomposition');
 Writeln(Lst);
 Writeln(Lst,'G= ',GroupSymbol[N,PointGroup]);
 Write(Lst,'F= ');
 Writeln (Lst,SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,J]]);
 Writeln(Lst);
 Writeln(Lst,'        The coset and double coset decomposition of the point group');
 Writeln(Lst,'      G= ',GroupSymbol[N,PointGroup],' with respect to the subgroup F= ',
             SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,J]]);
 Writeln(Lst);
 {$I+}
 IF IOResult<>0 THEN
  BEGIN
   ClrScr;
   Writeln;
   Writeln(' An error has occured with the printer, please check that the printer');
   Writeln(' is in proper order and press enter to try again.');
   Readln;
   ClrScr;
   Write(' Printing...');
   GOTO Take2;
  END;
 NumberRows:=GroupSize[PointGroup] DIV SgSize[GroupType[PointGroup],SubGroups[PointGroup,J]];
 NumberColumns:=SgSize[GroupType[PointGroup],SubGroups[PointGroup,J]];
 R:=1;
 LineNum:=7;
 Row[R]:=1;
 FOR K:=1 TO NumberColumns DO
  BEGIN
   Dynamic[R,K]:=SgElement[GroupType[PointGroup],SubGroups[PointGroup,J],K];
  END;
 REPEAT
  Check:=False;
  Doubles:=False;
  R:=R+1;
  211:FOR K:=1 TO GroupSize[PointGroup] DO
       BEGIN
        Search(ElementNum[PointGroup,K]);
        IF Check=True THEN GOTO 300;
       END;
  300:H:=ElementNum[PointGroup,K];
      Dynamic[R,1]:=H;
      FOR P:=1 TO NumberColumns DO
       BEGIN
        Dynamic[R,P]:=Mult[GroupType[PointGroup],Dynamic[R,1],Dynamic[1,P]];
       END;
  Row[R]:=1;
  400:FOR C:=1 TO NumberColumns DO
       BEGIN
        FOR K:=1 TO NumberColumns DO
         BEGIN
          Dynamic2[C,K]:=Mult[GroupType[PointGroup],Dynamic[1,C],Dynamic[R,K]];
         END;
       END;
  FOR C:=1 TO NumberColumns DO
   BEGIN
    Search(Dynamic2[C,1]);
    IF Check=True THEN
     BEGIN
      Doubles:=True;
      Row[R]:=0;
      R:=R+1;
      Row[R]:=1;
      FOR A:=1 TO NumberColumns DO
       Dynamic[R,A]:=Dynamic2[C,A];
     END;
   END;
    IF Doubles=True THEN
     BEGIN
      H:=Inverse[GroupType[PointGroup],Dynamic[R-1,1]];
      III:=Inverse[GroupType[PointGroup],Dynamic[R,1]];
     END
    ELSE H:=Inverse[GroupType[PointGroup],Dynamic[R,1]];
    Search(H);
    IF Check=True THEN
     BEGIN
      R:=R+1;
      Row[R-1]:=2;
      IF Doubles=True THEN
       BEGIN
        Row[R]:=0;
        Row[R+1]:=1;
       END
      ELSE Row[R]:=1;
      FOR A:=1 TO NumberColumns DO
       BEGIN
        Dynamic[R,A]:=Mult[GroupType[PointGroup],H,Dynamic[1,A]];
       END;
      IF Doubles=True THEN
       BEGIN
        GOTO 400;
       END;
     END;
 UNTIL R>=NumberRows;
 Writeln(Lst,'---------------------------------------------------------------------');
 LineNum:=LineNum+1;
 FOR MJ:=1 TO R DO
  BEGIN
   FOR W:=1 TO NumberColumns DO
    BEGIN
     Write(Lst,Elements[GroupType[PointGroup],N,Dynamic[MJ,W]],' ');
     IF ((W MOD 6)=0)AND(W<>NumberColumns) THEN
      BEGIN
       Writeln(Lst);
       LineNum:=LineNum+1;
      END;
     IF LineNum>59 THEN
      BEGIN
       FOR DD:=1 TO (66-LineNum) DO
        Writeln(Lst);
       LineNum:=0;
      END;
    END;
   IF Row[MJ]=0 THEN
    BEGIN
     Writeln(Lst);
     Writeln(Lst);
     LineNum:=LineNum+2;
    END;
   IF Row[MJ]=1 THEN
    BEGIN
     Writeln(Lst);
     Writeln(Lst,'--------------------------------------------------------------------');
     LineNum:=LineNum+2;
    END;
   IF Row[MJ]=2 THEN
    BEGIN
     Writeln(Lst);
     Writeln(Lst,'.   .   .   .   .   .   .   .   .   .   .   .   .   .   .   .   .   .');
     LineNum:=LineNum+2;
    END;
 IF LineNum>59 THEN
  BEGIN
   FOR DD:=1 TO (66-LineNum) DO
    Writeln(Lst);
   LineNum:=0;
  END;
 END;
 FOR DD:=1 TO (66-LineNum) DO
  Writeln(Lst);
 LineNum:=0;
END;

{ TypeCoset determines the coset decomposition of the subgroup and pointgroup
  in question. It first calculates the number of rows and columns of the
  decomposition. It then searches the coset to check if an element are
  contained, if the element is not contained it is added to the coset. Then
  the coset is searched for the products of the coset. If any products are
  not found, a new row in the coset is begun. Finally, the inverse of the
  first element is compared with the coset, if it is not found, another row
  is added. The cosets are printed a row at a time, after printing a row, an
  identifier is checked to determine which line marker to add, either a
  line, a dotted line, or a blank line. Upon completion the procedure is
  terminated.}

PROCEDURE TypeCoset(VAR Option:Char;VAR N,SubGroup,PointGroup:Integer;
                    VAR GroupSymbol:SymbolType;VAR SubSymbol:SubSymType;
                    VAR GroupType:SizeType;VAR SubGroups:SubGroupType;
                    VAR J:Integer;VAR NumberRows,NumberColumns:Integer;
                    VAR SgSize:SgSizeType;VAR O1:Integer);


LABEL 600,500,400,220,100,Quit,2,300,2301,209,210,27,212,30,211,22,2201,2200,2100,2120,2300,23;

VAR
 MJ,C,JQ,A,B,InvG,H,V,P,T,O,W,G,F,S,Q,K,L,LineNum,X,M,Code,WhereTo,NumberR,NumberR1:Integer;
 Options:STRING[2];

BEGIN
 FOR A:=1 TO 50 DO
  BEGIN
   FOR B:=1 TO 50 DO
    BEGIN
     Dynamic[A,B]:=0;
     Dynamic2[A,B]:=0;
    END;
   Row[A]:=0;
  END;
 Check:=False;
 Doubles:=False;
 Q:=1;
 T:=1;
 P:=1;
 G:=PointGroup;
 S:=J;
 ClrScr;
 LineNum:=0;
 IF O1=1 THEN
 BEGIN
 Writeln;
 Writeln('            Coset and Double Coset Decomposition');
 Writeln;
 Writeln('G= ',GroupSymbol[N,PointGroup]);
 Write('F= ');
 Writeln (SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,J]]);
 Writeln;
 Writeln('        The coset and double coset decomposition of the point group');
 Writeln('      G= ',GroupSymbol[N,PointGroup],' with respect to the subgroup F= ',
               SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,J]]);
 Writeln;
 END;
 NumberRows:=GroupSize[PointGroup] DIV SgSize[GroupType[PointGroup],SubGroups[PointGroup,J]];
 NumberColumns:=SgSize[GroupType[PointGroup],SubGroups[PointGroup,J]];
 R:=1;
 LineNum:=9;
 Row[R]:=1;
 FOR K:=1 TO NumberColumns DO
  BEGIN
   Dynamic[R,K]:=SgElement[GroupType[PointGroup],SubGroups[PointGroup,J],K];
  END;
REPEAT
 Check:=False;
 Doubles:=False;
 R:=R+1;
211:FOR K:=1 TO GroupSize[PointGroup] DO
     BEGIN
      Search(ElementNum[PointGroup,K]);
      IF Check=True THEN GOTO 300;
     END;
300:H:=ElementNum[PointGroup,K];
    Dynamic[R,1]:=H;
    FOR P:=1 TO NumberColumns DO
     BEGIN
      Dynamic[R,P]:=Mult[GroupType[PointGroup],Dynamic[R,1],Dynamic[1,P]];
     END;
Row[R]:=1;
400:FOR C:=1 TO NumberColumns DO
 BEGIN
  FOR K:=1 TO NumberColumns DO
   BEGIN
    Dynamic2[C,K]:=Mult[GroupType[PointGroup],Dynamic[1,C],Dynamic[R,K]];
   END;
 END;
FOR C:=1 TO NumberColumns DO
 BEGIN
  Search(Dynamic2[C,1]);
  IF Check=True THEN
   BEGIN
    Doubles:=True;
    Row[R]:=0;
    R:=R+1;
    Row[R]:=1;
    FOR A:=1 TO NumberColumns DO
     Dynamic[R,A]:=Dynamic2[C,A];
   END;
 END;
IF Doubles=True THEN
 BEGIN
  H:=Inverse[GroupType[PointGroup],Dynamic[R-1,1]];
  III:=Inverse[GroupType[PointGroup],Dynamic[R,1]];
 END
ELSE H:=Inverse[GroupType[PointGroup],Dynamic[R,1]];
Search(H);
 IF Check=True THEN
  BEGIN
   R:=R+1;
   Row[R-1]:=2;
   IF Doubles=True THEN
    BEGIN
     Row[R]:=0;
     Row[R+1]:=1;
    END
   ELSE Row[R]:=1;
   FOR A:=1 TO NumberColumns DO
    BEGIN
     Dynamic[R,A]:=Mult[GroupType[PointGroup],H,Dynamic[1,A]];
    END;
   IF Doubles=True THEN
    BEGIN
     GOTO 400;
    END;
  END;
UNTIL R>=NumberRows;
IF O1=1 THEN
 BEGIN
  Writeln('---------------------------------------------------------------------');
  LineNum:=LineNum+1;
  FOR MJ:=1 TO R DO
   BEGIN
    FOR W:=1 TO NumberColumns DO
     BEGIN
      Write(Elements[GroupType[PointGroup],N,Dynamic[MJ,W]],' ');
      IF ((W MOD 6)=0)AND(W<>NumberColumns) THEN
       BEGIN
        Writeln;
        LineNum:=LineNum+1;
       END;
      IF LineNum>=19 THEN
       BEGIN
        Write('Press enter to continue listing: ');
        Readln;
        LineNum:=0;
        ClrScr;
       END;
      END;
     IF Row[MJ]=0 THEN
      BEGIN
       Writeln;
       Writeln;
       LineNum:=LineNum+1;
      END;
     IF LineNum>=19 THEN
      BEGIN
       Write('Press enter to continue listing: ');
       Readln;
       LineNum:=0;
       ClrScr;
      END;
     IF Row[MJ]=1 THEN
      BEGIN
       Writeln;
       Writeln('---------------------------------------------------------------------');
       LineNum:=LineNum+2;
      END;
     IF LineNum>=19 THEN
      BEGIN
       Write('Press enter to continue listing: ');
       Readln;
       LineNum:=0;
       ClrScr;
      END;
     IF Row[MJ]=2 THEN
      BEGIN
       Writeln;
       Writeln('.   .   .   .   .   .   .   .   .   .   .   .   .   .   .   .   .   .');
       LineNum:=LineNum+2;
      END;
IF LineNum>=18 THEN
 BEGIN
  Write('Press enter to continue listing: ');
  Readln;
  ClrScr;
  LineNum:=0;
 END;
END;
Writeln('Press enter to continue: ');
Readln;
ClrScr;
END;
END;

{ ChooseSubGroup first inquires if the user if would like to see the
  calculations performed on a single subgroup of the selected pointgroup, or
  for all subgroups. If all subgroups are desired, the procedure will then
  begin the main portion of the program immediately. Otherwise, the subgroups
  of the pointgroup will be displayed and the user will be asked to select
  one. Multiple Repeat loops are used to help prevent user errors}

PROCEDURE ChooseSubGroup(VAR Back:Integer;VAR Option:Char;VAR N,SubGroup,PointGroup:Integer;
                         VAR GroupSymbol:SymbolType;VAR SubSymbol:SubSymType;
                         VAR GroupType:SizeType;VAR SubGroups:SubGroupType;
                         VAR GroupSize:SizeType;VAR SgSize:SgSizeType);

LABEL EndIt;

VAR
 LineNum,J,Code,AllOrOne:Integer;
 Options:STRING;

 BEGIN
  AllOrOne:=1;
  IF AllOrOne=1 THEN
   BEGIN
    REPEAT
     LineNum:=0;
     ClrScr;
     Writeln;
     Writeln('                 Choose a subgroup, F, of the point group, G=',GroupSymbol[N,PointGroup]);
     Writeln;
     Writeln;
     LineNum:=LineNum+4;
     FOR J:=1 TO SgNumber[PointGroup] DO
      BEGIN
       Writeln(J:2,') ',SubSymbol[GroupType[PointGroup],N,SubGroups[PointGroup,J]]);
       LineNum:=LineNum+1;
       IF LineNum>22 THEN
        BEGIN
         Write('                     Press enter to continue listing: ');
         Readln;
         ClrScr;
         LineNum:=0;
        END;
      END;
     Writeln;
     Writeln;
     IF SgNumber[PointGroup]=1 THEN
      BEGIN
       Write('             Type 1 and press enter: ');
      END
     ELSE Write('             Type 1-',SgNumber[PointGroup],' and press enter: ');
     Readln(Options);
     Val(Options,SubGroup,Code);
    UNTIL ((SubGroup<=SgNumber[PointGroup])AND(SubGroup>=1));
   END;
EndIt:END;

{ ChooseGroup presents the 32 pointgroups to the user and instructs to
  either choose one or exit to the main menu. A repeat loop is utilized
  in the event that the user inputs an invalid option or makes an error}

PROCEDURE ChooseGroup(VAR Option:Char;VAR N,SubGroup,PointGroup:Integer;
                      VAR GroupSymbol:SymbolType;VAR SubSymbol:SubSymType;
                      VAR GroupType:SizeType;VAR SubGroups:SubGroupType;
                      VAR GroupSize:SizeType;VAR SgSize:SgSizeType);

LABEL StartG,EndIt;

VAR
 J,Code:Integer;
 Options:STRING;

BEGIN
StartG:REPEAT
  ClrScr;
  Writeln;
  Writeln('                       Choose a point group G:');
  Writeln;
  Writeln;
  FOR J:=1 TO 16 DO
   Writeln(J:2,') ',GroupSymbol[N,J],J+16:4,') ',GroupSymbol[N,J+16]);
  Writeln;
  Writeln;
  Writeln;
  Write('                     Type point group number and press enter:  ');
  Readln(Options);
  Val(Options,PointGroup,Code);
  IF PointGroup=1 THEN
   BEGIN
    ClrScr;
    Writeln;
    Write('   Note: The point group ',GroupSymbol[N,1],' has no subgroups, please');
    Writeln(' pick another');
    Writeln('         point group.');
    Writeln;
    Write('                 Press enter to contine: ');
    Readln;
   END;
  UNTIL (PointGroup<=32)AND(PointGroup>1);
END;

{ ChangeNotation simply designates the desired notation, Schoenflies or
  International. Upon completion, the program returns to the main menu.}

PROCEDURE ChangeNotation(VAR N:Integer;VAR Option:Char);
BEGIN
 IF N=1 THEN
  BEGIN
   N:=2;
  END
 ELSE N:=1;
END;

PROCEDURE AskPrint(VAR Pose1:Integer);

VAR
 Options:Char;
 Code:Integer;

BEGIN
  REPEAT
  ClrScr;
  Writeln;
  Writeln('                   Output Options');
  Writeln;
  Writeln(' 1) Output printed to SCREEN and optionally to PRINTER');
  Writeln;
  Writeln(' 2) Output printed only to PRINTER');
  Writeln;
  Writeln(' M) Return to initial Menu');
  Writeln;
  Write  ('                                     Type 1, 2, or M: ');
  Options:=Readkey;
  Val(Options,Pose1,Code);
 UNTIL (Pose1=1)OR(Pose1=2)OR(Options='m')OR(Options='M');
 IF (Options='m')OR(Options='M') THEN Pose1:=3;
END;

PROCEDURE AskOptions(VAR Pose2:Integer);

VAR
 Options:Char;

BEGIN
 ClrScr;
 Writeln;
 Writeln(' Press p to print (Any other key to continue)');
 Options:=Readkey;
 IF (Options='p')OR(Options='P') THEN Pose2:=1;
END;

PROCEDURE WarnUser;

VAR
 Options:Char;

BEGIN
 REPEAT
 ClrScr;
 Writeln;
 Writeln('                            Printing Note');
 Writeln;
 Writeln('     In order to ensure proper printing, please check that the');
 Writeln(' printer is online and the print head is set at a desirable ');
 Writeln(' location near the top of a new page.');
 Writeln;
 Writeln;
 Write(' Press p to print ');
 Options:=Readkey;
 UNTIL (Options='p')OR(Options='P');
 ClrScr;
 Writeln('     printing...');
END;

PROCEDURE Director(VAR Option:Char;VAR N,SubGroup,PointGroup:Integer);

VAR
 A,B,C,LineNum,Pose1,Pose2,J,Code:Integer;
 Options:STRING;

LABEL
 Redund,Again,EndIt,Take2;

BEGIN
 Pose1:=0;Pose2:=0;O1:=0;O2:=0;O3:=0;O4:=0;O5:=0;O6:=0;O7:=0;
 J:=SubGroup;
 IF Option='1' THEN
  BEGIN
   O1:=1;
   AskPrint(Pose1);
   IF Pose1=3 THEN GOTO EndIt;
   IF Pose1=2 THEN
    BEGIN
     WarnUser;
     PrintCoset(Option,N,SubGroup,PointGroup,GroupSymbol,SubSymbol,
                              GroupType,SubGroups,J);
    END;
   IF Pose1=1 THEN
    BEGIN
     TypeCoset(Option,N,SubGroup,PointGroup,GroupSymbol,SubSymbol,GroupType,
               SubGroups,J,NumberRows,NumberColumns,SgSize,O1);
     AskOptions(Pose2);
     IF Pose2=1 THEN
      BEGIN
       WarnUser;
       PrintCoset(Option,N,SubGroup,PointGroup,GroupSymbol,
                  SubSymbol,GroupType,SubGroups,J);
     END;
    END;
   O1:=0;
  END
 ELSE IF Option='2' THEN
  BEGIN
   O2:=1;
   TypeCoset(Option,N,SubGroup,PointGroup,GroupSymbol,SubSymbol,GroupType,
             SubGroups,J,NumberRows,NumberColumns,SgSize,O1);
   AskPrint(Pose1);
   IF Pose1=3 THEN GOTO EndIt;
   IF Pose1=2 THEN
    BEGIN
     WarnUser;
     PrintTransition(Option,N,SubGroup,PointGroup,J);
    END;
   IF Pose1=1 THEN
    BEGIN
     Transition(Option,N,SubGroup,PointGroup,J,O2);
     AskOptions(Pose2);
     IF Pose2=1 THEN
      BEGIN
       WarnUser;
       PrintTransition(Option,N,SubGroup,PointGroup,J);
      END;
    END;
   O2:=0;
  END
 ELSE IF Option='3' THEN
  BEGIN
  O3:=1;
  TypeCoset(Option,N,SubGroup,PointGroup,GroupSymbol,SubSymbol,GroupType,SubGroups,
            J,NumberRows,NumberColumns,SgSize,O1);
  Transition(Option,N,SubGroup,PointGroup,J,O2);
  AskPrint(Pose1);
  IF Pose1=3 THEN GOTO EndIt;
  IF Pose1=2 THEN
   BEGIN
    WarnUser;
    PrintPermutation(Option,N,SubGroup,PointGroup,J);
   END;
  IF Pose1=1 THEN
   BEGIN
    Permutation(Option,N,SubGroup,PointGroup,J,O3);
    AskOptions(Pose2);
    IF Pose2=1 THEN
     BEGIN
      WarnUser;
      PrintPermutation(Option,N,SubGroup,PointGroup,J);
     END;
   END;
   O3:=0;
  END
 ELSE IF Option='4' THEN
  BEGIN
   O4:=1;
   TypeCoset(Option,N,SubGroup,PointGroup,GroupSymbol,SubSymbol,GroupType,SubGroups,
             J,NumberRows,NumberColumns,SgSize,O1);
   Transition(Option,N,SubGroup,PointGroup,J,O2);
   Permutation(Option,N,SubGroup,PointGroup,J,O3);
   TwinLaws(Option,N,SubGroup,PointGroup,J,O5);
   AskPrint(Pose1);
   IF Pose1=3 THEN GOTO EndIt;
   IF Pose1=2 THEN
    BEGIN
     WarnUser;
     PrintClasses(Option,N,SubGroup,PointGroup,J);
    END;
   IF Pose1=1 THEN
    BEGIN
     Classes(Option,N,SubGroup,PointGroup,J,O4);
     AskOptions(Pose2);
     IF Pose2=1 THEN
      BEGIN
       WarnUser;
       PrintClasses(Option,N,SubGroup,PointGroup,J);
      END;
    END;
  END
 ELSE IF Option='5' THEN
  BEGIN
   O5:=1;
   TypeCoset(Option,N,SubGroup,PointGroup,GroupSymbol,SubSymbol,GroupType,SubGroups,
             J,NumberRows,NumberColumns,SgSize,O1);
   Transition(Option,N,SubGroup,PointGroup,J,O2);
   Permutation(Option,N,SubGroup,PointGroup,J,O3);
   AskPrint(Pose1);
   IF Pose1=3 THEN GOTO EndIt;
   IF Pose1=2 THEN
    BEGIN
     WarnUser;
     PrintTwinLaws(Option,N,SubGroup,PointGroup,J);
    END;
   IF Pose1=1 THEN
    BEGIN
     TwinLaws(Option,N,SubGroup,PointGroup,J,O5);
     AskOptions(Pose2);
     IF Pose2=1 THEN
      BEGIN
       WarnUser;
       PrintTwinLaws(Option,N,SubGroup,PointGroup,J);
      END;
    END;
   O5:=0;
  END
 ELSE IF Option='6' THEN
  BEGIN
  O6:=1;
  TypeCoset(Option,N,SubGroup,PointGroup,GroupSymbol,SubSymbol,GroupType,SubGroups,
            J,NumberRows,NumberColumns,SgSize,O1);
  Transition(Option,N,SubGroup,PointGroup,J,O2);
  Permutation(Option,N,SubGroup,PointGroup,J,O3);
  REPEAT
   LineNum:=0;
   NumShown:=0;
   AA:=1;
   ClrScr;
   Writeln;
   Writeln(' Choose g of {S(1),gS(1)}');
   Writeln;
   LineNum:=3;
Again:FOR A:=AA TO GroupSize[PointGroup] DO
     BEGIN
     FOR B:=1 TO SgSize[GroupType[PointGroup],SubGroups[PointGroup,SubGroup]] DO
      BEGIN
       IF SgElement[GroupType[PointGroup],SubGroups[PointGroup,SubGroup],B]=ElementNum[PointGroup,A] THEN
        BEGIN
         GChoice[A]:=0;
         AA:=A+1;
         GOTO Again;
        END;
      END;
      Writeln(' ',NumShown+1:2,') ',Elements[GroupType[PointGroup],N,ElementNum[PointGroup,A]]);
      NumShown:=NumShown+1;
      GChoice[NumShown]:=A{ElementNum[PointGroup,A]};
      LineNum:=LineNum+1;
      IF LineNum>=23 THEN
       BEGIN
        Writeln;
        Write(' Press enter to continue listing: ');
        Readln;
        ClrScr;
        LineNum:=0;
       END;
    END;
   Writeln;
   Write(' Please choose g and press enter: ');
   Readln(Options);
   Val(Options,GVar,Code);
  UNTIL (GVar>=1)AND(GVar<=NumShown);
  AskPrint(Pose1);
  IF Pose1=3 THEN GOTO EndIt;
  IF Pose1=2 THEN
   BEGIN
    WarnUser;
    PrintArbitraryOne(Option,N,SubGroup,PointGroup,J,GVar);
   END;
  IF Pose1=1 THEN
   BEGIN
    ArbitraryOne(Option,N,SubGroup,PointGroup,J,O6,GVar);
    AskOptions(Pose2);
    IF Pose2=1 THEN
     BEGIN
      WarnUser;
      PrintArbitraryOne(Option,N,SubGroup,PointGroup,J,GVar);
     END;
   END;
  O6:=0;
  END
 ELSE IF Option='7' THEN
  BEGIN
   O7:=1;
   TypeCoset(Option,N,SubGroup,PointGroup,GroupSymbol,SubSymbol,GroupType,SubGroups,
             J,NumberRows,NumberColumns,SgSize,O1);
   Transition(Option,N,SubGroup,PointGroup,J,O2);
   Permutation(Option,N,SubGroup,PointGroup,J,O3);
   REPEAT
Redund:ClrScr;
      Writeln;
      Writeln('                      Twin Laws of Domain Pair {S(i),S(j)}');
      Writeln;
      Write('  Please choose i (1-',R,') and press enter: ');
      Readln(Options);
      Val(Options,IVar,Code);
      IF (IVar<1)OR(IVar>R) THEN GOTO Redund;
      Write('  Please choose j (1-',R,') and press enter: ');
      Readln(Options);
      Val(Options,JVar,Code);
      IF (IVar=JVar)AND(IVar<=R)AND(IVar>=1) THEN
       BEGIN
        Clrscr;
        Writeln;
        Writeln('  Note: The case involving i=j=',JVar,' is a trivial domain pair as it consists');
        Writeln('        of two identical domains, please choose two different domains.');
        Writeln;
        Writeln('        press enter to continue');
        Readln;
       END;
   UNTIL (JVar<>IVar)AND(IVar<=R)AND(IVar>=1)AND(JVar<=R)AND(JVar>=1);
   AskPrint(Pose1);
   IF Pose1=3 THEN GOTO EndIt;
   IF Pose1=2 THEN
    BEGIN
     WarnUser;
     PrintArbitraryTwin(Option,N,SubGroup,PointGroup,J);
    END;
   IF Pose1=1 THEN
    BEGIN
     ArbitraryTwin(Option,N,SubGroup,PointGroup,J,O7);
     AskOptions(Pose2);
     IF Pose2=1 THEN
      BEGIN
       WarnUser;
       PrintArbitraryTwin(Option,N,SubGroup,PointGroup,J);
      END;
    END;
   O7:=0;
  END;
EndIt:END;

{ CaseIt is used as a director of options for the user. It will do one of
  three things: display the choosegroup menu, change the notation or exit
  the program. It assists the program in allowing the user to complete
  multiple runs.}

PROCEDURE CaseIt(VAR Option:Char;VAR N,SubGroup,PointGroup:Integer;
                 VAR GroupSymbol:SymbolType;VAR SubSymbol:SubSymType;
                 VAR GroupType:SizeType;VAR SubGroups:SubGroupType;
                 VAR GroupSize:SizeType;VAR SgSize:SgSizeType);

BEGIN
 CASE Option OF
  '1','2','3','4','5','6','7':Director(Option,N,SubGroup,PointGroup);
  '8':ChangeNotation(N,Option);
  'a','A':ChooseGroup(Option,N,SubGroup,PointGroup,GroupSymbol,SubSymbol,
                  GroupType,SubGroups,GroupSize,SgSize);
  'b','B':ChooseSubGroup(Back,Option,N,SubGroup,PointGroup,GroupSymbol,SubSymbol,GroupType,SubGroups,
                         GroupSize,SgSize);
  'e','E':END;
  IF (Option='a')OR(Option='A') THEN
   ChooseSubGroup(Back,Option,N,SubGroup,PointGroup,GroupSymbol,SubSymbol,GroupType,SubGroups,
                  GroupSize,SgSize);
END;

BEGIN
 N:=1;
 Initialize(GroupSize,GroupType,Elements,ElementNum,Mult,Inverse,SgSize,
            SgElement,SgNumber,SubGroups,GroupSymbol,SubSymbol);
 Introduction(Option,N);
 ChooseGroup(Option,N,SubGroup,PointGroup,GroupSymbol,SubSymbol,GroupType,
             SubGroups,GroupSize,SgSize);
 ChooseSubGroup(Back,Option,N,SubGroup,PointGroup,GroupSymbol,SubSymbol,GroupType,SubGroups,
                GroupSize,SgSize);
 Menu(Option,PointGroup,SubGroup,G,N);
 REPEAT
  CaseIt(Option,N,SubGroup,PointGroup,GroupSymbol,SubSymbol,GroupType,
         SubGroups,GroupSize,SgSize);
  IF (Option<>'E')AND(Option<>'e') THEN Menu(Option,PointGroup,SubGroup,G,N);
 UNTIL (Option='E')OR(Option='e');
 ClrScr;
END.